/*
 * name: Debug.cpp
 * description: simulate crosscommexe.exe
 * author: tilman jochems
 * (c)13/05/2010, mfj, rivesaltes
 */

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "Debug.h"

//construction
TCrossDebug::TCrossDebug(){
 CrossIsConnected=false;
}//TCrossDebug

//connect to crosscommexe
bool TCrossDebug::ConnectToCross(wchar_t *str,short s1){
 static ulong time=0;
 if(time==0){time=GetTickCount(); return false;}
 CrossIsConnected=(GetTickCount()-time>5000);
 return CrossIsConnected;
}//ConnectToCross

//is all ok?
bool TCrossDebug::KrcOk(long *timeout){
 Sleep(1000);
 return true;
}//KrcOk

 //show a global variable
bool TCrossDebug::ShowVar(wchar_t *str,wchar_t **res,long *timeout){
 int i1;
 static float inc[6]={5,1,3,2,1,-1};
 static float a[6]={0,10,-20,3,5,10};

 if(a[0]>185 || a[0]<-185)  inc[0]*=-1;
 if(a[1]>25  || a[1]<-145)   inc[1]*=-1;
 if(a[2]>160  || a[2]<-120)   inc[2]*=-1;
 if(a[3]>350  || a[3]<-350)   inc[3]*=-1;
 if(a[4]>130  || a[4]<-130)   inc[4]*=-1;
 if(a[5]>350 || a[5]<-350)  inc[5]*=-1;
 for(i1=0;i1<6;i1++) a[i1]+=inc[i1];

 AnsiString in(str);
 if(in=="$AXIS_ACT"){
  swprintf(*res,L"$AXIS_ACT = {E6AXIS: A1 %f, A2 %f, A3 %f, A4 %f, A5 %f, A6 %f",
   a[0],a[1],a[2],a[3],a[4],a[5]);
  return true;
 }//if
 return false;
}//ShowVar

//the end
void TCrossDebug::ServerOff(){
 CrossIsConnected=false;
}

