/*
 *name: MDialog.h
 *description: read $AXIS_ACT from OfficeLite and send to vitual arm
 *author: tilman jochems
 *(c)06/06/2010, mfj, rivesaltes
 */

#ifndef MDialogH
#define MDialogH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ExtCtrls.hpp>
#include <winsock2.h>
#include "CrossLib_OCX.h"
#include <OleCtrls.hpp>

typedef unsigned long ulong;

class TFMDialog : public TForm
{
__published:
        TPanel *PCross;
        TLabel *LA0;
        TLabel *Label1;
        TLabel *LA1;
        TLabel *Label3;
        TLabel *LA2;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *LA3;
        TLabel *Label8;
        TLabel *LA4;
        TLabel *Label10;
        TLabel *LA5;
        TLabel *LMessage;
        TPanel *PArm;
        TEdit *EAddress;
        TButton *BSet;
        TTimer *TMessage;
        TCross *Cross;
        void __fastcall FormHide(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall BSetClick(TObject *Sender);
        void __fastcall TMessageTimer(TObject *Sender);
        void __fastcall EAddressKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall CrossCmdMessage(TObject *Sender, short nJob,
          long lError);
private:
        char Buf[128];                  //buffer for general use
        long Timeout;                   //timeout for reading
        bool  SleepStart;               //officelite starts
        short Job;                      //actuel job
        bool  JobOk;                    //job has finished
        WideString Position;            //position returned from rob
        bool   AddressOk;               //address of socket ok
        SOCKET Socket;                  //socket server side
        struct sockaddr_in Address;     //address
        TLabel *LA[6];                  //for visu
        void __fastcall IdleHandler(TObject* Sender,bool &Done);
public:
        void MessageWrite(AnsiString msg,bool warn=false);
        void FatalError(AnsiString msg);
        __fastcall TFMDialog(TComponent* Owner);
};

extern PACKAGE TFMDialog *FMDialog;
#endif
