// ************************************************************************ //
// AVERTISSEMENT                                                                 
// -------                                                                    
// Les types dclars dans ce fichier ont t gnrs  partir de donnes lues 
// depuis la bibliothque de types. Si cette dernire (via une autre bibliothque de types 
// s'y rfrant) est explicitement ou indirectement r-importe, ou la commande "Rafrachir"  
// de l'diteur de bibliothque de types est active lors de la modification de la bibliothque 
// de types, le contenu de ce fichier sera rgnr et toutes les modifications      
// manuellement apportes seront perdues.                                     
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.134.1.39  $
// Fichier gnr le 02/11/2010 16:12:30 depuis la bibliothque de types ci-dessous.

// ************************************************************************ //
// Bibl.Types     : C:\KRC\LIB\Cross.ocx (1)
// IID\LCID       : {2CF18AA6-25B1-11CF-918D-0020AF3C12CE}\0
// Fichier d'aide : 
// DepndLst       : 
//   (1) v2.0 stdole, (C:\WINNT\system32\stdole2.tlb)
//   (2) v4.0 StdVCL, (C:\WINNT\system32\STDVCL40.DLL)
//   (3) v3.1 WBF_TimeLib, (C:\KRC\lib\WBF_Time.dll)
// ************************************************************************ //
#ifndef   __CrossLib_OCX_h__
#define   __CrossLib_OCX_h__

#pragma option push -b -w-inl

#include <utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0500)
//
// Le code gnr par l'utilitaire TLIBIMP ou par les fonctionnalits Import|TypeLibrary 
// et Import|ActiveX de C++Builder dpendent des versions spcifiques du fichier 
// en-tte UTILCLS.H trouv dans le rpertoire INCLUDE\VCL. Si une version plus 
// ancienne du fichier est dtecte, vous avez probablement besoin d'une mise  jour.
//
#error "Ce fichier a besoin d'une version plus rcente du fichier en-tte UTILCLS.H" \
       "Vous devez appliquer une mise  jour  votre copie de C++Builder"
#endif
#include <olectl.h>
#include <ocidl.h>
#if !defined(_NO_VCL)
#include <stdvcl.hpp>
#endif  //   _NO_VCL
#include <ocxproxy.h>
#include "WBF_TimeLib_TLB.h"

#include "CrossLib_TLB.h"
namespace Crosslib_tlb
{

// *********************************************************************//
// Chane d'aide : KUKA-Cross-OCX
// Version :    3.15
// *********************************************************************//


// *********************************************************************//
// Dclaration de classe Proxy coposant COM
// Nom du composant     : TCross
// Chane d'aide        : KUKA-Cross-OCX
// Interface par dfaut : _DCross
// Objet Intf. par df. : _DCrossDisp
// DISP Intf. par df.? : Yes
// Interface vnement  : _DCrossEvents
// TypeFlags            : (34) CanCreate Control
// *********************************************************************//

// *********************************************************************//
// Dfinition des fermetures pour permettre aux gestionnaires VCL d'intercepter les vnements OCX.      
// *********************************************************************//
typedef void __fastcall (__closure * TCrossCmdMessage)(System::TObject * Sender, 
                                                       short nJob, long lError);
typedef void __fastcall (__closure * TCrossBOFKey)(System::TObject * Sender, 
                                                   short nKey);
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
// Classe Proxy pour hberger  KUKA-Cross-OCX dans les applications et/ou l'EDI CBuilder.
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
class PACKAGE TCross : public TOleControl
{
  OVERLOADED_PROP_METHODS;
  static TNoParam  OptParam;
  static GUID      DEF_CTL_INTF;

  // Instance de Closures pour exposer les vnements OCX comme ceux de la VCL
  //
  TCrossCmdMessage               FOnCmdMessage;
  TCrossBOFKey                   FOnBOFKey;

  // Interface d'OCX par dfaut
  //
  _DCrossDisp m_OCXIntf;

  // proprits VCL Getters/Setters qui dlguent  l'OCX
  //

  // Variables statiques utilises par toutes les instances de proxy OCX
  //
  static int          EventDispIDs[2];
  static TControlData CControlData;
  static GUID         CTL_DEF_INTF;

  // Mthode fournissant un accs  l'interface comme __property
  //
  _DCrossDisp __fastcall GetDefaultInterface();
  _DCrossDisp __fastcall GetControlInterface()
  { return GetDefaultInterface(); }

protected:
  void     __fastcall CreateControl  ();
  void     __fastcall InitControlData();

public:
  virtual  __fastcall TCross(TComponent* AOwner) : TOleControl(AOwner)
  {};
  virtual  __fastcall TCross(HWND        Parent) : TOleControl(Parent)
  {};

  // Mthodes OCX
  //
  TOLEBOOL        __fastcall GetRobots(BSTR* pbstrRobots/*[out]*/);
  TOLEBOOL        __fastcall MeldungResult(short nAsync/*[in]*/, short* pnVerwaltung/*[out]*/, 
                                           short* pnMeldung/*[out]*/, BSTR* pbstrGruppe/*[out]*/, 
                                           BSTR* pbstrVerursacher/*[out]*/, 
                                           BSTR* pbstrMeldText/*[out]*/);
  TOLEBOOL        __fastcall MeldungAdeResult(short nAsync/*[in]*/, short* pnVerwaltung/*[out]*/);
  TOLEBOOL        __fastcall CmdError(short nJob/*[in]*/, short* pnVerwaltung/*[out]*/, 
                                      short* pnMeldung/*[out]*/, BSTR* pbstrGruppe/*[out]*/, 
                                      BSTR* pbstrVerursacher/*[out]*/, BSTR* pbstrMeldText/*[out]*/);
  TOLEBOOL        __fastcall DialogQuestion(short nJob/*[in]*/, short* pnVerwaltung/*[out]*/, 
                                            short* pnMeldung/*[out]*/, BSTR* pbstrGruppe/*[out]*/, 
                                            BSTR* pbstrVerursacher/*[out]*/, 
                                            BSTR* pbstrQuestion/*[out]*/, 
                                            BSTR* pbstrAnswers/*[out]*/);
  TOLEBOOL        __fastcall DialogAnswer(short nJob/*[in]*/, short nVerwaltung/*[in]*/, 
                                          short nAnswer/*[in]*/);
  short           __fastcall Dir(BSTR strKRCDir/*[in]*/, BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall DirResult(short nJob/*[in]*/, BSTR* pbstrDir/*[out]*/);
  short           __fastcall DownLoad(BSTR strFile/*[in]*/, BSTR strKRCDest/*[in]*/, 
                                      BSTR strOpt/*[in]*/);
  short           __fastcall DownLoadMem(BSTR strFile/*[in]*/, BSTR strKRCDest/*[in]*/, 
                                         BSTR strOpt/*[in]*/, BSTR* pMem/*[in]*/, 
                                         long nLaenge/*[in]*/);
  TOLEBOOL        __fastcall DownLoadResult(short nJob/*[in]*/);
  short           __fastcall UpLoad(BSTR strKrcFile/*[in]*/, BSTR strPath/*[in]*/, 
                                    BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall UpLoadResult(short nJob/*[in]*/);
  short           __fastcall UpLoadMem(BSTR strKrcFile/*[in]*/, BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall UpLoadMemResult(short nJob/*[in]*/, BSTR* pbstrMem/*[out]*/);
  short           __fastcall Delete(BSTR strKrcFile/*[in]*/, BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall DeleteResult(short nJob/*[in]*/);
  short           __fastcall ShowVar(BSTR strVar/*[in]*/, BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall ShowVarResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/);
  short           __fastcall SetVar(BSTR strVar/*[in]*/, BSTR strValue/*[in]*/);
  TOLEBOOL        __fastcall SetVarResult(short nJob/*[in]*/);
  short           __fastcall SetInfo(BSTR strVar/*[in]*/, BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall SetInfoResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/);
  short           __fastcall Run(BSTR strProg/*[in]*/, BSTR strParam/*[in]*/);
  TOLEBOOL        __fastcall RunResult(short nJob/*[in]*/);
  short           __fastcall Start(void);
  TOLEBOOL        __fastcall StartResult(short nJob/*[in]*/);
  short           __fastcall StartOff(void);
  TOLEBOOL        __fastcall StartOffResult(short nJob/*[in]*/);
  short           __fastcall Stop(void);
  TOLEBOOL        __fastcall StopResult(short nJob/*[in]*/);
  short           __fastcall StopOff(void);
  TOLEBOOL        __fastcall StopOffResult(short nJob/*[in]*/);
  short           __fastcall Confirm(short nVerwaltung/*[in]*/);
  TOLEBOOL        __fastcall ConfirmResult(short nJob/*[in]*/);
  short           __fastcall GetMessageBuffer(void);
  TOLEBOOL        __fastcall GetMessageBufferResult(short nJob/*[in]*/);
  short           __fastcall Reset(void);
  TOLEBOOL        __fastcall ResetResult(short nJob/*[in]*/);
  short           __fastcall Cancel(void);
  TOLEBOOL        __fastcall CancelResult(short nJob/*[in]*/);
  short           __fastcall Select(BSTR strProg/*[in]*/, BSTR strParam/*[in]*/);
  TOLEBOOL        __fastcall SelectResult(short nJob/*[in]*/);
  short           __fastcall Move(short nAxis/*[in]*/, TOLEBOOL bDirection/*[in]*/);
  TOLEBOOL        __fastcall MoveResult(short nJob/*[in]*/);
  short           __fastcall MoveOff(short nAxis/*[in]*/, TOLEBOOL bDirection/*[in]*/);
  TOLEBOOL        __fastcall MoveOffResult(short nJob/*[in]*/);
  short           __fastcall Move6D(void);
  TOLEBOOL        __fastcall Move6DResult(short nJob/*[in]*/);
  short           __fastcall Move6DOff(void);
  TOLEBOOL        __fastcall Move6DOffResult(short nJob/*[in]*/);
  short           __fastcall EditOpen(short nModus/*[in]*/, BSTR strFile/*[in]*/);
  TOLEBOOL        __fastcall EditOpenResult(short nJob/*[in]*/);
  short           __fastcall EditClose(short nModus/*[in]*/);
  TOLEBOOL        __fastcall EditCloseResult(short nJob/*[in]*/);
  short           __fastcall EditInsert(short nSatz/*[in]*/, BSTR strDaten/*[in]*/);
  TOLEBOOL        __fastcall EditInsertResult(short nJob/*[in]*/);
  short           __fastcall EditChange(short nSatz/*[in]*/, BSTR strDaten/*[in]*/);
  TOLEBOOL        __fastcall EditChangeResult(short nJob/*[in]*/);
  short           __fastcall EditRedecl(BSTR strDaten/*[in]*/);
  TOLEBOOL        __fastcall EditRedeclResult(short nJob/*[in]*/);
  short           __fastcall EditDelete(short nSatz/*[in]*/);
  TOLEBOOL        __fastcall EditDeleteResult(short nJob/*[in]*/);
  short           __fastcall Install(void);
  TOLEBOOL        __fastcall InstallResult(short nJob/*[in]*/);
  short           __fastcall EndInstall(void);
  TOLEBOOL        __fastcall EndInstallResult(short nJob/*[in]*/);
  short           __fastcall Adjust(short nAxis/*[in]*/, BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall AdjustResult(short nJob/*[in]*/);
  short           __fastcall Copy(BSTR strKrcSrc/*[in]*/, BSTR strKRCDest/*[in]*/, 
                                  BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall CopyResult(short nJob/*[in]*/);
  short           __fastcall EditPrint(short nSatz/*[in]*/);
  TOLEBOOL        __fastcall EditPrintResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/);
  short           __fastcall EditDescrMode(short nModus/*[in]*/);
  TOLEBOOL        __fastcall EditDescrModeResult(short nJob/*[in]*/);
  TOLEBOOL        __fastcall CmdAbort(short nJob/*[in]*/);
  short           __fastcall StopSteu(BSTR strOpt/*[in]*/);
  short           __fastcall CancelSteu(BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall PHGGet6DMouse(short nJob/*[in]*/, short* pnX/*[out]*/, 
                                           short* pnY/*[out]*/, short* pnZ/*[out]*/, 
                                           short* pnA/*[out]*/, short* pnB/*[out]*/, 
                                           short* pnC/*[out]*/);
  TOLEBOOL        __fastcall RobMoveResult(short nJob/*[in]*/);
  short           __fastcall RobMovePTP(BSTR bstrParam/*[in]*/);
  short           __fastcall RobMoveLIN(BSTR bstrParam/*[in]*/);
  short           __fastcall RobMovePTP_REL(BSTR bstrParam/*[in]*/);
  short           __fastcall RobMoveLIN_REL(BSTR bstrParam/*[in]*/);
  TOLEBOOL        __fastcall KeySwitchResult(short nJob/*[in]*/, short* pnKeySwitchX/*[out]*/);
  short           __fastcall EditMaDaOk(void);
  TOLEBOOL        __fastcall EditMaDaOkResult(short nJob/*[in]*/);
  short           __fastcall AkkuOff(void);
  TOLEBOOL        __fastcall AkkuOffResult(short nJob/*[in]*/);
  TOLEBOOL        __fastcall Init(BSTR strMyName/*[in]*/, BSTR strRob/*[in]*/, long nAsync/*[in]*/);
  TOLEBOOL        __fastcall Exit(void);
  short           __fastcall OCEditInsert(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                          short nSatz/*[in]*/, BSTR strDaten/*[in]*/);
  TOLEBOOL        __fastcall OCEditInsertResult(short nJob/*[in]*/);
  short           __fastcall OCEditChange(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                          short nSatz/*[in]*/, BSTR strDaten/*[in]*/);
  TOLEBOOL        __fastcall OCEditChangeResult(short nJob/*[in]*/);
  short           __fastcall OCEditRedecl(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                          BSTR strDaten/*[in]*/);
  TOLEBOOL        __fastcall OCEditRedeclResult(short nJob/*[in]*/);
  short           __fastcall OCEditDelete(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                          short nSatz/*[in]*/);
  TOLEBOOL        __fastcall OCEditDeleteResult(short nJob/*[in]*/);
  short           __fastcall EditAnalyse(BSTR strFile/*[in]*/);
  TOLEBOOL        __fastcall EditAnalyseResult(short nJob/*[in]*/);
  short           __fastcall DPShowVar(BSTR strDataPath/*[in]*/, BSTR strVar/*[in]*/, 
                                       BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall DPShowVarResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/);
  short           __fastcall DPSetVar(BSTR strDataPath/*[in]*/, BSTR strVar/*[in]*/, 
                                      BSTR strValue/*[in]*/);
  TOLEBOOL        __fastcall DPSetVarResult(short nJob/*[in]*/);
  short           __fastcall IORestart(short nBus/*[in]*/);
  TOLEBOOL        __fastcall IORestartResult(short nJob/*[in]*/);
  short           __fastcall IOBusInfo(void);
  TOLEBOOL        __fastcall IOBusInfoResult(short nJob/*[in]*/, long* nBus/*[out]*/);
  short           __fastcall OCEditDeleteBlock(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                               short nSatz/*[in]*/, short nLines/*[in]*/);
  TOLEBOOL        __fastcall OCEditDeleteBlockResult(short nJob/*[in]*/);
  short           __fastcall KRCOk(void);
  TOLEBOOL        __fastcall KRCOkResult(short nJob/*[in]*/);
  TOLEBOOL        __fastcall WriteLogFile(BSTR strFile/*[in]*/);
  TOLEBOOL        __fastcall MeldungFilter(short nMeldung/*[in]*/, TOLEBOOL bAdd/*[in]*/);
  TOLEBOOL        __fastcall BOFKeyFilter(short nBOFKey/*[in]*/, TOLEBOOL bAdd/*[in]*/);
  short           __fastcall ChangeAccess(BSTR strKrcFile/*[in]*/, BSTR strAccess/*[in]*/);
  TOLEBOOL        __fastcall ChangeAccessResult(short nJob/*[in]*/);
  short           __fastcall ChangeUser(BSTR strKrcFile/*[in]*/, BSTR strUser/*[in]*/);
  TOLEBOOL        __fastcall ChangeUserResult(short nJob/*[in]*/);
  short           __fastcall ChangeComment(BSTR strKrcFile/*[in]*/, BSTR strComment/*[in]*/);
  TOLEBOOL        __fastcall ChangeCommentResult(short nJob/*[in]*/);
  short           __fastcall EditExec(BSTR strCmdLine/*[in]*/);
  TOLEBOOL        __fastcall EditExecResult(short nJob/*[in]*/);
  short           __fastcall DisableStart(TOLEBOOL bDisable/*[in]*/, BSTR strErrMsg/*[in]*/);
  TOLEBOOL        __fastcall DisableStartResult(short nJob/*[in]*/);
  TOLEBOOL        __fastcall GetProgressInfo(short nJob/*[in]*/, short* nProgress/*[out]*/, 
                                             BSTR* strInfo/*[out]*/);
  short           __fastcall GetActiveModule(BSTR strPath/*[in]*/);
  TOLEBOOL        __fastcall GetActiveModuleResult(short nJob/*[in]*/, BSTR* strModule/*[out]*/);
  short           __fastcall VolumeGetProp(BSTR strRoot/*[in]*/);
  TOLEBOOL        __fastcall VolumeGetPropResult(short nJob/*[in]*/, BSTR* strName/*[out]*/, 
                                                 long* eVolumeType/*[out]*/, long* nTotal/*[out]*/, 
                                                 long* nFree/*[out]*/, long* nUsed/*[out]*/);
  short           __fastcall VolumeSetName(BSTR strRoot/*[in]*/, BSTR strNewName/*[in]*/);
  TOLEBOOL        __fastcall VolumeSetNameResult(short nJob/*[in]*/);
  short           __fastcall VolumeFormat(BSTR strRoot/*[in]*/, BSTR strNewName/*[in]*/, 
                                          TOLEBOOL bQuick/*[in]*/);
  TOLEBOOL        __fastcall VolumeFormatResult(short nJob/*[in]*/);
  short           __fastcall VolumeNameList(void);
  TOLEBOOL        __fastcall VolumeNameListResult(short nJob/*[in]*/, TVariant* astrNames/*[out]*/);
  short           __fastcall ItemSetName(BSTR strOldName/*[in]*/, BSTR strNewName/*[in]*/);
  TOLEBOOL        __fastcall ItemSetNameResult(short nJob/*[in]*/);
  short           __fastcall ItemSetAttribute(BSTR strName/*[in]*/, long dwAttributes/*[in]*/, 
                                              long dwMask/*[in]*/);
  TOLEBOOL        __fastcall ItemSetAttributeResult(short nJob/*[in]*/);
  short           __fastcall ItemNameList(BSTR strName/*[in]*/, long eType/*[in]*/, 
                                          TOLEBOOL bRecursive/*[in]*/);
  TOLEBOOL        __fastcall ItemNameListResult(short nJob/*[in]*/, TVariant* astrNames/*[out]*/);
  short           __fastcall ItemCreate(BSTR strPathName/*[in]*/, BSTR strName/*[in]*/, 
                                        long eType/*[in]*/, long eModulePart/*[in]*/, 
                                        BSTR strTemplate/*[in]*/, long dwCreateFlags/*[in]*/);
  TOLEBOOL        __fastcall ItemCreateResult(short nJob/*[in]*/);
  short           __fastcall ItemDestroy(BSTR strName/*[in]*/, long dwDestryFlags/*[in]*/);
  TOLEBOOL        __fastcall ItemDestroyResult(short nJob/*[in]*/);
  short           __fastcall ItemCopy(BSTR strSrcName/*[in]*/, BSTR strDestName/*[in]*/, 
                                      long dwCopyFlags/*[in]*/);
  short           __fastcall ItemCopySrcMem(TVariant* abSrc/*[in]*/, BSTR strDestName/*[in]*/, 
                                            long dwCopyFlags/*[in]*/);
  short           __fastcall ItemCopyDestMem(BSTR strSrcName/*[in]*/, long dwCopyFlags/*[in]*/);
  TOLEBOOL        __fastcall ItemCopyResult(short nJob/*[in]*/);
  TOLEBOOL        __fastcall ItemCopyResultMem(short nJob/*[in]*/, TVariant* abDest/*[out]*/);
  short           __fastcall ItemMove(BSTR strSrcName/*[in]*/, BSTR strDestName/*[in]*/, 
                                      long dwCopyFlags/*[in]*/);
  TOLEBOOL        __fastcall ItemMoveResult(short nJob/*[in]*/);
  short           __fastcall ItemCompare(BSTR strSrcName/*[in]*/, BSTR strDestName/*[in]*/);
  TOLEBOOL        __fastcall ItemCompareResult(short nJob/*[in]*/, TOLEBOOL* bEqual/*[out]*/);
  TOLEBOOL        __fastcall ItemSelectResult(short nJob/*[in]*/);
  TOLEBOOL        __fastcall ItemRunResult(short nJob/*[in]*/);
  short           __fastcall ItemReset(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ItemResetResult(short nJob/*[in]*/);
  short           __fastcall ItemStart(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ItemStartResult(short nJob/*[in]*/);
  short           __fastcall ItemStop(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ItemStopResult(short nJob/*[in]*/);
  short           __fastcall ItemCancel(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ItemCancelResult(short nJob/*[in]*/);
  short           __fastcall ItemAnalyse(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ItemAnalyseResult(short nJob/*[in]*/);
  short           __fastcall ModuleCodeGetProp(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeGetPropResult(short nJob/*[in]*/, long* nLines/*[out]*/, 
                                                     long* eCodeType/*[out]*/);
  TOLEBOOL        __fastcall ModuleCodeOpenResult(short nJob/*[in]*/, long* nHandle/*[out]*/);
  TOLEBOOL        __fastcall ModuleCodeCloseResult(short nJob/*[in]*/);
  short           __fastcall ModuleCodeGetLines(long nHandle/*[in]*/, long nStart/*[in]*/, 
                                                long nCount/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeGetLinesResult(short nJob/*[in]*/, 
                                                      TVariant* astrLines/*[out]*/);
  short           __fastcall ModuleCodeInsertLines(long nHandle/*[in]*/, long nStart/*[in]*/, 
                                                   TVariant* astrLines/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeInsertLinesResult(short nJob/*[in]*/);
  short           __fastcall ModuleCodeDeleteLines(long nHandle/*[in]*/, long nStart/*[in]*/, 
                                                   long nCount/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeDeleteLinesResult(short nJob/*[in]*/);
  short           __fastcall ModuleCodeReplaceLines(long nHandle/*[in]*/, long nStart/*[in]*/, 
                                                    long nCount/*[in]*/, 
                                                    TVariant* astrNewLines/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeReplaceLinesResult(short nJob/*[in]*/, 
                                                          TVariant* astrOldLines/*[out]*/);
  short           __fastcall ModuleCodeRedeclare(long nHandle/*[in]*/, BSTR strName/*[in]*/, 
                                                 BSTR strType/*[in]*/, BSTR strValue/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeRedeclareResult(short nJob/*[in]*/);
  short           __fastcall ModuleCodeFind(long nHandle/*[in]*/, BSTR strFind/*[in]*/, 
                                            long nStartLine/*[in]*/, long nStartColumn/*[in]*/, 
                                            long nEndLine/*[in]*/, long nEndColumn/*[in]*/, 
                                            TOLEBOOL bWord/*[in]*/, TOLEBOOL bMatchCase/*[in]*/, 
                                            TOLEBOOL bSearchRevers/*[in]*/, 
                                            TOLEBOOL bPattern/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeFindResult(short nJob/*[in]*/, long* nStartLine/*[out]*/, 
                                                  long* nStartColumn/*[out]*/, 
                                                  long* nEndLine/*[out]*/, long* nEndColumn/*[out]*/);
  short           __fastcall ModuleCodeFindStruct(long nHandle/*[in]*/, long nLine/*[in]*/, 
                                                  long eStructKind/*[in]*/, TOLEBOOL bStart/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeFindStructResult(short nJob/*[in]*/, long* nLine/*[out]*/, 
                                                        long* eStructKind/*[out]*/, 
                                                        BSTR* strStruct/*[out]*/);
  short           __fastcall ModuleCodeSelectLine(long nHandle/*[in]*/, long nLine/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeSelectLineResult(short nJob/*[in]*/);
  short           __fastcall ErrorGetProp(BSTR strName/*[in]*/, long nIndex/*[in]*/);
  TOLEBOOL        __fastcall ErrorGetPropResult(short nJob/*[in]*/, BSTR* strModule/*[out]*/, 
                                                long* nLine/*[out]*/, long* nColumn/*[out]*/, 
                                                long* nError/*[out]*/, BSTR* strParam/*[out]*/);
  short           __fastcall ErrorList(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ErrorListResult(short nJob/*[in]*/, TVariant* astrModules/*[out]*/, 
                                             TVariant* anLine/*[out]*/, TVariant* anColumn/*[out]*/, 
                                             TVariant* anError/*[out]*/, 
                                             TVariant* astrParams/*[out]*/);
  short           __fastcall ModuleInformationGetProp(BSTR strName/*[in]*/, long dwMask/*[in]*/);
  short           __fastcall ModuleInformationSetProp(BSTR strName/*[in]*/, long dwMask/*[in]*/, 
                                                      TOLEBOOL bVisible/*[in]*/, 
                                                      TOLEBOOL bReadable/*[in]*/, 
                                                      BSTR strUser/*[in]*/, BSTR strComment/*[in]*/);
  TOLEBOOL        __fastcall ModuleInformationSetPropResult(short nJob/*[in]*/);
  short           __fastcall ModuleInformationGetUserAttribute(BSTR strName/*[in]*/, 
                                                               BSTR strAttrib/*[in]*/);
  TOLEBOOL        __fastcall ModuleInformationGetUserAttributeResult(short nJob/*[in]*/, 
                                                                     BSTR* strValue/*[out]*/);
  short           __fastcall ModuleInformationSetUserAttribute(BSTR strName/*[in]*/, 
                                                               BSTR strAttrib/*[in]*/, 
                                                               BSTR strValue/*[in]*/);
  TOLEBOOL        __fastcall ModuleInformationSetUserAttributeResult(short nJob/*[in]*/);
  short           __fastcall ModuleInformationUserAttributesList(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ModuleInformationUserAttributesListResult(short nJob/*[in]*/, 
                                                                       TVariant* astrNames/*[out]*/, 
                                                                       TVariant* astrValues/*[out]*/);
  short           __fastcall ModuleDependenciesList(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ModuleDependenciesListResult(short nJob/*[in]*/, 
                                                          TVariant* astrDependencies/*[out]*/);
  TOLEBOOL        __fastcall NotifyVolumeResult(short nJob/*[in]*/, long* dwChanged/*[out]*/);
  TOLEBOOL        __fastcall NotifyItemResult(short nJob/*[in]*/, long* dwChanged/*[out]*/);
  TOLEBOOL        __fastcall NotifyModuleInformationResult(short nJob/*[in]*/, 
                                                           long* dwChanged/*[out]*/);
  TOLEBOOL        __fastcall NotifyModuleCodeResult(short nJob/*[in]*/, long* dwChanged/*[out]*/);
  short           __fastcall ItemGetProp(BSTR strName/*[in]*/, long dwMask/*[in]*/);
  TOLEBOOL        __fastcall ItemGetPropResult(short nJob/*[in]*/, long* eItemType/*[out]*/, 
                                               BSTR* strName/*[out]*/, long* dwSize/*[out]*/, 
                                               long* dwAttributes/*[out]*/, 
                                               DATE* pdateTimeCreated/*[out]*/, 
                                               DATE* pdateTimeAccess/*[out]*/, 
                                               DATE* pdateTimeModified/*[out]*/, 
                                               long* eEditMode/*[out]*/);
  short           __fastcall ItemSelect(BSTR strName/*[in]*/, BSTR strParams/*[in]*/, 
                                        long dwOptions/*[in]*/);
  short           __fastcall ItemRun(BSTR strName/*[in]*/, BSTR strParams/*[in]*/, 
                                     long dwOptions/*[in]*/);
  TOLEBOOL        __fastcall ModuleInformationGetPropResult(short nJob/*[in]*/, 
                                                            long* eSourceType/*[out]*/, 
                                                            long* nDataSize/*[out]*/, 
                                                            long* nSourceSize/*[out]*/, 
                                                            long* nSonCounter/*[out]*/, 
                                                            long* nRelease/*[out]*/, 
                                                            TOLEBOOL* bPredefined/*[out]*/, 
                                                            TOLEBOOL* bOldParent/*[out]*/, 
                                                            TOLEBOOL* bParent/*[out]*/, 
                                                            TOLEBOOL* bVisible/*[out]*/, 
                                                            TOLEBOOL* bReadable/*[out]*/, 
                                                            TOLEBOOL* bErrors/*[out]*/, 
                                                            TOLEBOOL* bChanged/*[out]*/, 
                                                            TOLEBOOL* bHasData/*[out]*/, 
                                                            BSTR* strUser/*[out]*/, 
                                                            BSTR* strComment/*[out]*/, 
                                                            long* eItemState0/*[out]*/, 
                                                            long* eItemState1/*[out]*/);
  short           __fastcall NotifyVolume(BSTR strRoot/*[in]*/, long dwMask/*[in]*/, 
                                          long lMinRecTime/*[in]*/);
  short           __fastcall NotifyItem(BSTR strName/*[in]*/, long* dwMask/*[out]*/, 
                                        long lMinRecTime/*[in]*/);
  short           __fastcall NotifyModuleInformation(BSTR strName/*[in]*/, long* dwMask/*[out]*/, 
                                                     long lMinRecTime/*[in]*/);
  short           __fastcall NotifyModuleCode(BSTR strName/*[in]*/, long* dwMask/*[out]*/, 
                                              long lMinRecTime/*[in]*/);
  short           __fastcall GetFullName(BSTR strKRCName/*[in]*/);
  TOLEBOOL        __fastcall GetFullNameResult(short nJob/*[in]*/, BSTR* strFullName/*[out]*/);
  short           __fastcall GetKRCName(BSTR strFullName/*[in]*/);
  TOLEBOOL        __fastcall GetKRCNameResult(short nJob/*[in]*/, BSTR* strKRCName/*[out]*/);
  short           __fastcall AnalyseMode(long bAll/*[in]*/);
  TOLEBOOL        __fastcall AnalyseModeResult(short nJob/*[in]*/);
  short           __fastcall FlushLog(void);
  TOLEBOOL        __fastcall FlushLogResult(short nJob/*[in]*/);
  short           __fastcall GetLogHeader(void);
  TOLEBOOL        __fastcall GetLogHeaderResult(short nJob/*[in]*/, TVariant* astrHeader/*[out]*/);
  short           __fastcall ModuleCodeOpen(BSTR strName/*[in]*/, long dwMode/*[in]*/, 
                                            long dwEditMode/*[in]*/, BSTR strModule/*[in]*/, 
                                            BSTR strErrorKey/*[in]*/);
  short           __fastcall ModuleCodeClose(long nHandle/*[in]*/, TOLEBOOL bSave/*[in]*/, 
                                             long dwEditMode/*[in]*/);
  short           __fastcall GetActiveInterface(void);
  TOLEBOOL        __fastcall GetActiveInterfaceResult(short nJob/*[in]*/, TOLEBOOL* bActive/*[out]*/);
  short           __fastcall SetActiveInterface(void);
  TOLEBOOL        __fastcall SetActiveInterfaceResult(short nJob/*[in]*/);
  short           __fastcall NotifyActiveInterface(void);
  TOLEBOOL        __fastcall NotifyActiveInterfaceResult(short nJob/*[in]*/, 
                                                         TOLEBOOL* bActive/*[out]*/);
  short           __fastcall DPSetInfo(BSTR strDataPath/*[in]*/, BSTR strVar/*[in]*/, 
                                       BSTR strOpt/*[in]*/);
  TOLEBOOL        __fastcall DPSetInfoResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/);
  short           __fastcall ItemLink(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ItemLinkResult(short nJob/*[in]*/);
  short           __fastcall ItemUnlink(BSTR strName/*[in]*/);
  TOLEBOOL        __fastcall ItemUnlinkResult(short nJob/*[in]*/);
  short           __fastcall ModuleCodeReOpen(long nHandle/*[in]*/, long dwMode/*[in]*/, 
                                              long dwEditMode/*[in]*/, BSTR strModule/*[in]*/, 
                                              BSTR strErrorKey/*[in]*/);
  TOLEBOOL        __fastcall ModuleCodeReOpenResult(short nJob/*[in]*/, long* nHandle/*[out]*/);
  short           __fastcall VxWinGetConfig(void);
  TOLEBOOL        __fastcall VxWinGetConfigResult(short nJob/*[in]*/, TOLEBOOL* pbForceCold/*[out]*/);
  short           __fastcall VxWinSetConfig(TOLEBOOL bForceCold/*[in]*/);
  TOLEBOOL        __fastcall VxWinSetConfigResult(short nJob/*[in]*/);
  short           __fastcall LogGetConfig(void);
  TOLEBOOL        __fastcall LogGetConfigResult(short nJob/*[in]*/, long* pnMaxEntries/*[out]*/);
  short           __fastcall LogSetConfig(long nMaxEntries/*[in]*/);
  TOLEBOOL        __fastcall LogSetConfigResult(short nJob/*[in]*/);
  short           __fastcall ItemGetCRC(BSTR strName/*[in]*/, TOLEBOOL bBinary/*[in]*/);
  TOLEBOOL        __fastcall ItemGetCRCResult(short nJob/*[in]*/, long* pdwCRC/*[out]*/);
  short           __fastcall OCEditInsertBlock(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                               short nStart/*[in]*/, TVariant* astrLines/*[in]*/);
  TOLEBOOL        __fastcall OCEditInsertBlockResult(short nJob/*[in]*/);
  short           __fastcall LogAddItem(BSTR strSource/*[in]*/, BSTR strInstance/*[in]*/, 
                                        long nMessage/*[in]*/, short nLogLevel/*[in]*/, 
                                        BSTR strDBModule/*[in]*/, BSTR strDBKey/*[in]*/, 
                                        BSTR strDBShortKey/*[in]*/, TVariant* astrParams/*[in]*/, 
                                        TVariant* abDBParams/*[in]*/, BSTR strOptional/*[in]*/, 
                                        long eLogClass/*[in]*/, long eLogType/*[in]*/);
  TOLEBOOL        __fastcall LogAddItemResult(short nJob/*[in]*/, long* pnLogNumber/*[out]*/);
  short           __fastcall LogOCGetItem(long nFirst/*[in]*/);
  TOLEBOOL        __fastcall LogOCGetItemResult(short nJob/*[in]*/, long* pnActItems/*[out]*/, 
                                                DATE* pdateTimeStamp/*[out]*/, 
                                                short* pnMilliseconds/*[out]*/, 
                                                long* pnLogNumber/*[out]*/, 
                                                BSTR* pbstrSource/*[out]*/, 
                                                BSTR* pbstrInstance/*[out]*/, 
                                                long* pnMessage/*[out]*/, short* pnLogLevel/*[out]*/, 
                                                BSTR* pbstrDBModule/*[out]*/, 
                                                BSTR* pbstrDBKey/*[out]*/, 
                                                BSTR* pbstrDBShortKey/*[out]*/, 
                                                TVariant* pastrParams/*[out]*/, 
                                                TVariant* pabDBParams/*[out]*/, 
                                                BSTR* pbstrOptional/*[out]*/, 
                                                long* peLogClass/*[out]*/, long* peLogType/*[out]*/);
  short           __fastcall LogOpen(long dwFilter/*[in]*/);
  TOLEBOOL        __fastcall LogOpenResult(short nJob/*[in]*/, long* pdwHandle/*[out]*/);
  short           __fastcall LogClose(long dwHandle/*[in]*/);
  TOLEBOOL        __fastcall LogCloseResult(short nJob/*[in]*/);
  short           __fastcall LogGetItem(long dwHandle/*[in]*/, long nFirst/*[in]*/, 
                                        TOLEBOOL bUseBookmark/*[in]*/);
  TOLEBOOL        __fastcall LogGetItemResult(short nJob/*[in]*/, long* pnActItems/*[out]*/, 
                                              DATE* pdateTimeStamp/*[out]*/, 
                                              short* pnMilliseconds/*[out]*/, 
                                              long* pnLogNumber/*[out]*/, BSTR* pbstrSource/*[out]*/, 
                                              BSTR* pbstrInstance/*[out]*/, long* pnMessage/*[out]*/, 
                                              short* pnLogLevel/*[out]*/, 
                                              BSTR* pbstrDBModule/*[out]*/, 
                                              BSTR* pbstrDBKey/*[out]*/, 
                                              BSTR* pbstrDBShortKey/*[out]*/, 
                                              TVariant* pastrParams/*[out]*/, 
                                              TVariant* pabDBParams/*[out]*/, 
                                              BSTR* pbstrOptional/*[out]*/, 
                                              long* peLogClass/*[out]*/, long* peLogType/*[out]*/);
  short           __fastcall LogExport(BSTR strFileName/*[in]*/, long eExport/*[in]*/, 
                                       long dwFilter/*[in]*/);
  TOLEBOOL        __fastcall LogExportResult(short nJob/*[in]*/);
  short           __fastcall LogPrint(long dwFilter/*[in]*/);
  TOLEBOOL        __fastcall LogPrintResult(short nJob/*[in]*/);
  TOLEBOOL        __fastcall GetSyncAddMessage(short nJob/*[in]*/, 
                                               Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                               long* pdwMsgHandle/*[out]*/, 
                                               long* peMessageType/*[out]*/, 
                                               long* pdwMessage/*[out]*/, 
                                               BSTR* pbstrDBModule/*[out]*/, 
                                               BSTR* pbstrDBCause/*[out]*/, 
                                               BSTR* pbstrDBMessage/*[out]*/, 
                                               TVariant* astrParams/*[out]*/, 
                                               TVariant* abDBParams/*[out]*/);
  TOLEBOOL        __fastcall GetSyncAddDialog(short nJob/*[in]*/, 
                                              Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                              long* pdwMsgHandle/*[out]*/, 
                                              long* peMessageType/*[out]*/, 
                                              long* pdwMessage/*[out]*/, 
                                              BSTR* pbstrDBModule/*[out]*/, 
                                              BSTR* pbstrDBCause/*[out]*/, 
                                              BSTR* pbstrDBMessage/*[out]*/, 
                                              TVariant* astrParams/*[out]*/, 
                                              TVariant* abDBParams/*[out]*/, 
                                              TVariant* astrAnswers/*[out]*/, 
                                              TVariant* abDBAnswers/*[out]*/);
  TOLEBOOL        __fastcall SyncAnswer(short nJob/*[in]*/, long dwMsgHandle/*[in]*/, 
                                        short nAnswer/*[in]*/);
  TOLEBOOL        __fastcall GetAsyncAddMessage(short nAsync/*[in]*/, 
                                                Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                                long* pdwMsgHandle/*[out]*/, 
                                                long* peMessageType/*[out]*/, 
                                                long* pdwMessage/*[out]*/, 
                                                BSTR* pbstrDBModule/*[out]*/, 
                                                BSTR* pbstrDBCause/*[out]*/, 
                                                BSTR* pbstrDBMessage/*[out]*/, 
                                                TVariant* astrParams/*[out]*/, 
                                                TVariant* abDBParams/*[out]*/);
  TOLEBOOL        __fastcall GetAsyncAddDialog(short nAsync/*[in]*/, 
                                               Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                               long* pdwMsgHandle/*[out]*/, 
                                               long* peMessageType/*[out]*/, 
                                               long* pdwMessage/*[out]*/, 
                                               BSTR* pbstrDBModule/*[out]*/, 
                                               BSTR* pbstrDBCause/*[out]*/, 
                                               BSTR* pbstrDBMessage/*[out]*/, 
                                               TVariant* astrParams/*[out]*/, 
                                               TVariant* abDBParams/*[out]*/, 
                                               TVariant* astrAnswers/*[out]*/, 
                                               TVariant* abDBAnswers/*[out]*/);
  TOLEBOOL        __fastcall GetAsyncSubMessage(short nAsync/*[in]*/, 
                                                Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                                long* pdwMsgHandle/*[out]*/);
  TOLEBOOL        __fastcall GetAsyncConfirm(short nAsync/*[in]*/, long* pdwMsgHandle/*[out]*/);
  TOLEBOOL        __fastcall GetAsyncAnswer(short nAsync/*[in]*/, long* pdwMsgHandle/*[out]*/, 
                                            short* pnAnswer/*[out]*/);
  short           __fastcall AsyncAddMessage(Wbf_timelib_tlb::IFileTimePtr pTime/*[in]*/, 
                                             long dwMsgHandle/*[in]*/, long eMessageType/*[in]*/, 
                                             long dwMessage/*[in]*/, BSTR bstrDBModule/*[in]*/, 
                                             BSTR bstrDBCause/*[in]*/, BSTR bstrDBMessage/*[in]*/, 
                                             TVariant* astrParams/*[in]*/, 
                                             TVariant* abDBParams/*[in]*/);
  TOLEBOOL        __fastcall AsyncAddMessageResult(short nJob/*[in]*/, long* pdwMsgHandle/*[out]*/);
  short           __fastcall AsyncAddDialog(Wbf_timelib_tlb::IFileTimePtr pTime/*[in]*/, 
                                            long dwMsgHandle/*[in]*/, long eMessageType/*[in]*/, 
                                            long dwMessage/*[in]*/, BSTR bstrDBModule/*[in]*/, 
                                            BSTR bstrDBCause/*[in]*/, BSTR bstrDBMessage/*[in]*/, 
                                            TVariant* astrParams/*[in]*/, 
                                            TVariant* abDBParams/*[in]*/, 
                                            TVariant* astrAnswers/*[in]*/, 
                                            TVariant* abDBAnswers/*[in]*/);
  TOLEBOOL        __fastcall AsyncAddDialogResult(short nJob/*[in]*/, long* pdwMsgHandle/*[out]*/);
  short           __fastcall AsyncSubMessage(long dwMsgHandle/*[in]*/);
  TOLEBOOL        __fastcall AsyncSubMessageResult(short nJob/*[in]*/);
  short           __fastcall AsyncConfirm(long dwMsgHandle/*[in]*/);
  TOLEBOOL        __fastcall AsyncConfirmResult(short nJob/*[in]*/);
  short           __fastcall AsyncAnswer(long dwMsgHandle/*[in]*/, short nAnswer/*[in]*/);
  TOLEBOOL        __fastcall AsyncAnswerResult(short nJob/*[in]*/);
  short           __fastcall MoveKey(short nAxis/*[in]*/, TOLEBOOL bDirection/*[in]*/, 
                                     short nKey/*[in]*/);
  TOLEBOOL        __fastcall MoveKeyResult(short nJob/*[in]*/);
  short           __fastcall MoveKeyOff(short nAxis/*[in]*/, TOLEBOOL bDirection/*[in]*/, 
                                        short nKey/*[in]*/);
  TOLEBOOL        __fastcall MoveKeyOffResult(short nJob/*[in]*/);
  short           __fastcall PowerGetStartType(void);
  TOLEBOOL        __fastcall PowerGetStartTypeResult(short nJob/*[in]*/, short* pnStartType/*[out]*/);
  short           __fastcall PowerSetStartType(short nStartType/*[in]*/);
  TOLEBOOL        __fastcall PowerSetStartTypeResult(short nJob/*[in]*/);

  // Proprits OCX
  //
  __property _DCrossDisp ControlInterface={ read=GetDefaultInterface };

  // Proprits publies
  //
__published:

  // Proprits standard
  //

  // Proprits OCX
  //

  // Evnements OCX
  //
  __property TCrossCmdMessage OnCmdMessage={ read=FOnCmdMessage, write=FOnCmdMessage };
  __property TCrossBOFKey OnBOFKey={ read=FOnBOFKey, write=FOnBOFKey };
};
typedef TCross  TCrossProxy;

};     // namespace Crosslib_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Crosslib_tlb;
#endif

#pragma option pop

#endif // __CrossLib_OCX_h__
