// ************************************************************************ //
// AVERTISSEMENT                                                                 
// -------                                                                    
// Les types dclars dans ce fichier ont t gnrs  partir de donnes lues 
// depuis la bibliothque de types. Si cette dernire (via une autre bibliothque de types 
// s'y rfrant) est explicitement ou indirectement r-importe, ou la commande "Rafrachir"  
// de l'diteur de bibliothque de types est active lors de la modification de la bibliothque 
// de types, le contenu de ce fichier sera rgnr et toutes les modifications      
// manuellement apportes seront perdues.                                     
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.134.1.39  $
// Fichier gnr le 13/05/2010 10:38:11 depuis la bibliothque de types ci-dessous.

// ************************************************************************ //
// Bibl.Types     : C:\KRC\util\CrossCommEXE.exe (1)
// IID\LCID       : {CCCACE96-1B8B-4249-AE4F-5382E3E5C34F}\0
// Fichier d'aide : 
// DepndLst       : 
//   (1) v2.0 stdole, (C:\WINNT\system32\stdole2.tlb)
//   (2) v4.0 StdVCL, (C:\WINNT\system32\STDVCL40.DLL)
// ************************************************************************ //

#include <vcl.h>
#pragma hdrstop

#if defined(USING_ATL)
#include <atl\atlvcl.h>
#endif

#include "CrossCommEXE_OCX.h"

#if !defined(__PRAGMA_PACKAGE_SMART_INIT)
#define      __PRAGMA_PACKAGE_SMART_INIT
#pragma package(smart_init)
#endif

namespace Crosscommexe_tlb
{

_CrossCommandPtr& TCrossCommand::GetDefaultInterface()
{
  if (!m_DefaultIntf)
    Connect();
  return m_DefaultIntf;
}

_di_IUnknown __fastcall TCrossCommand::GetDunk()
{
  _di_IUnknown diUnk;
  if (m_DefaultIntf) {
    IUnknownPtr punk = m_DefaultIntf;
    diUnk = LPUNKNOWN(punk);
  }
  return diUnk;
}

void __fastcall TCrossCommand::Connect()
{
  if (!m_DefaultIntf) {
    _di_IUnknown punk = GetServer();
    m_DefaultIntf = punk;
    if (ServerData->EventIID != GUID_NULL)
      ConnectEvents(GetDunk());
  }
}

void __fastcall TCrossCommand::Disconnect()
{
  if (m_DefaultIntf) {
    
    if (ServerData->EventIID != GUID_NULL)
      DisconnectEvents(GetDunk());
    m_DefaultIntf.Reset();
  }
}

void __fastcall TCrossCommand::BeforeDestruction()
{
  Disconnect();
}

void __fastcall TCrossCommand::ConnectTo(_CrossCommandPtr intf)
{
  Disconnect();
  m_DefaultIntf = intf;
  if (ServerData->EventIID != GUID_NULL)
    ConnectEvents(GetDunk());
}

void __fastcall TCrossCommand::InitServerData()
{
  static Oleserver::TServerData sd;
  sd.ClassID = CLSID_CrossCommand;
  sd.IntfIID = __uuidof(_CrossCommand);
  sd.EventIID= GUID_NULL;
  ServerData = &sd;
}


};     // namespace Crosscommexe_tlb


// *********************************************************************//
// La fonction Register est invoque par l'EDI lorsque ce module est 
// install dans un paquet. Il fournit la liste des composants (y-compris
// les OCX) implments par ce module. L'implmentation ci-dessous
// informe l'EDI des classes proxy OCX implmentes ici.
// *********************************************************************//
namespace Crosscommexe_ocx
{

void __fastcall PACKAGE Register()
{
  // [1]
  TComponentClass cls_svr[] = {
                              __classid(Crosscommexe_tlb::TCrossCommand)
                           };
  RegisterComponents("ActiveX", cls_svr,
                     sizeof(cls_svr)/sizeof(cls_svr[0])-1);
}

};     // namespace Crosscommexe_ocx
