// ************************************************************************ //
// AVERTISSEMENT                                                                 
// -------                                                                    
// Les types dclars dans ce fichier ont t gnrs  partir de donnes lues 
// depuis la bibliothque de types. Si cette dernire (via une autre bibliothque de types 
// s'y rfrant) est explicitement ou indirectement r-importe, ou la commande "Rafrachir"  
// de l'diteur de bibliothque de types est active lors de la modification de la bibliothque 
// de types, le contenu de ce fichier sera rgnr et toutes les modifications      
// manuellement apportes seront perdues.                                     
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.134.1.39  $
// Fichier gnr le 04/06/2010 09:57:32 depuis la bibliothque de types ci-dessous.

// ************************************************************************ //
// Bibl.Types     : C:\KRC\lib\Cross.ocx (1)
// IID\LCID       : {2CF18AA6-25B1-11CF-918D-0020AF3C12CE}\0
// Fichier d'aide : 
// DepndLst       : 
//   (1) v2.0 stdole, (C:\WINNT\system32\stdole2.tlb)
//   (2) v4.0 StdVCL, (C:\WINNT\system32\STDVCL40.DLL)
//   (3) v1.1 WBF_TimeLib, (C:\KRC\lib\WBF_Time.dll)
// ************************************************************************ //

#include <vcl.h>
#pragma hdrstop

#if defined(USING_ATL)
#include <atl\atlvcl.h>
#endif

#include "CrossLib_OCX.h"

#if !defined(__PRAGMA_PACKAGE_SMART_INIT)
#define      __PRAGMA_PACKAGE_SMART_INIT
#pragma package(smart_init)
#endif

namespace Crosslib_tlb
{



// *********************************************************************//
// IMPLEMENTATION CLASSE PROXY OCX
// (Les variables/mthodes suivantes implmentent la classe TCross qui
// permet  "KUKA-Cross-OCX" d'tre hberg dans les applications/l'EDI CBuilder).
// *********************************************************************//
int   TCross::EventDispIDs[2] = {
    0x00000001, 0x00000002};

TControlData TCross::CControlData =
{
  // GUID de CoClass Interface d'vnements du Contrle
  {0x2CF18AA3, 0x25B1, 0x11CF,{ 0x91, 0x8D, 0x00, 0x20, 0xAF, 0x3C, 0x12, 0xCE} }, // CoClass
  {0x2CF18AA5, 0x25B1, 0x11CF,{ 0x91, 0x8D, 0x00, 0x20, 0xAF, 0x3C, 0x12, 0xCE} }, // Evnements

  // Nombre d'vnements et table de leurs DISPIDs
  2, &EventDispIDs,

  // Pointeur sur la chane de licence d'excution
  NULL,  // HRESULT(0x80004005)

  // Indicateurs pour OnChanged PropertyNotification
  0x00000000,
  300,// (Version EDI)

  // Nombre de Font Prop et table de leurs DISPIDs
  0, NULL,

  // Nombre de Pict Prop et table de leurs DISPIDs
  0, NULL,
  0, // Rserv
  0, // Nombre d'instances (usage interne)
  0, // Liste des descriptions d'Enum (interne)
};

GUID     TCross::DEF_CTL_INTF = {0x2CF18AA4, 0x25B1, 0x11CF,{ 0x91, 0x8D, 0x00, 0x20, 0xAF, 0x3C, 0x12, 0xCE} };
TNoParam TCross::OptParam;

static inline void ValidCtrCheck(TCross *)
{
   delete new TCross((TComponent*)(0));
};

void __fastcall TCross::InitControlData()
{
  ControlData = &CControlData;
};

void __fastcall TCross::CreateControl()
{
  if (!m_OCXIntf)
  {
    _ASSERTE(DefaultDispatch);
    DefaultDispatch->QueryInterface(DEF_CTL_INTF, (LPVOID*)&m_OCXIntf);
  }
};

_DCrossDisp __fastcall TCross::GetDefaultInterface()
{
  CreateControl();
  return m_OCXIntf;
};

TOLEBOOL __fastcall TCross::GetRobots(BSTR* pbstrRobots/*[out]*/)
{
  return GetDefaultInterface()->GetRobots(pbstrRobots/*[out]*/);
}

TOLEBOOL __fastcall TCross::MeldungResult(short nAsync/*[in]*/, short* pnVerwaltung/*[out]*/, 
                                          short* pnMeldung/*[out]*/, BSTR* pbstrGruppe/*[out]*/, 
                                          BSTR* pbstrVerursacher/*[out]*/, 
                                          BSTR* pbstrMeldText/*[out]*/)
{
  return GetDefaultInterface()->MeldungResult(nAsync/*[in]*/, pnVerwaltung/*[out]*/, 
                                              pnMeldung/*[out]*/, pbstrGruppe/*[out]*/, 
                                              pbstrVerursacher/*[out]*/, pbstrMeldText/*[out]*/);
}

TOLEBOOL __fastcall TCross::MeldungAdeResult(short nAsync/*[in]*/, short* pnVerwaltung/*[out]*/)
{
  return GetDefaultInterface()->MeldungAdeResult(nAsync/*[in]*/, pnVerwaltung/*[out]*/);
}

TOLEBOOL __fastcall TCross::CmdError(short nJob/*[in]*/, short* pnVerwaltung/*[out]*/, 
                                     short* pnMeldung/*[out]*/, BSTR* pbstrGruppe/*[out]*/, 
                                     BSTR* pbstrVerursacher/*[out]*/, BSTR* pbstrMeldText/*[out]*/)
{
  return GetDefaultInterface()->CmdError(nJob/*[in]*/, pnVerwaltung/*[out]*/, pnMeldung/*[out]*/, 
                                         pbstrGruppe/*[out]*/, pbstrVerursacher/*[out]*/, 
                                         pbstrMeldText/*[out]*/);
}

TOLEBOOL __fastcall TCross::DialogQuestion(short nJob/*[in]*/, short* pnVerwaltung/*[out]*/, 
                                           short* pnMeldung/*[out]*/, BSTR* pbstrGruppe/*[out]*/, 
                                           BSTR* pbstrVerursacher/*[out]*/, 
                                           BSTR* pbstrQuestion/*[out]*/, BSTR* pbstrAnswers/*[out]*/)
{
  return GetDefaultInterface()->DialogQuestion(nJob/*[in]*/, pnVerwaltung/*[out]*/, 
                                               pnMeldung/*[out]*/, pbstrGruppe/*[out]*/, 
                                               pbstrVerursacher/*[out]*/, pbstrQuestion/*[out]*/, 
                                               pbstrAnswers/*[out]*/);
}

TOLEBOOL __fastcall TCross::DialogAnswer(short nJob/*[in]*/, short nVerwaltung/*[in]*/, 
                                         short nAnswer/*[in]*/)
{
  return GetDefaultInterface()->DialogAnswer(nJob/*[in]*/, nVerwaltung/*[in]*/, nAnswer/*[in]*/);
}

short __fastcall TCross::Dir(BSTR strKRCDir/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->Dir(strKRCDir/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::DirResult(short nJob/*[in]*/, BSTR* pbstrDir/*[out]*/)
{
  return GetDefaultInterface()->DirResult(nJob/*[in]*/, pbstrDir/*[out]*/);
}

short __fastcall TCross::DownLoad(BSTR strFile/*[in]*/, BSTR strKRCDest/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->DownLoad(strFile/*[in]*/, strKRCDest/*[in]*/, strOpt/*[in]*/);
}

short __fastcall TCross::DownLoadMem(BSTR strFile/*[in]*/, BSTR strKRCDest/*[in]*/, 
                                     BSTR strOpt/*[in]*/, BSTR* pMem/*[in]*/, long nLaenge/*[in]*/)
{
  return GetDefaultInterface()->DownLoadMem(strFile/*[in]*/, strKRCDest/*[in]*/, strOpt/*[in]*/, 
                                            pMem/*[in]*/, nLaenge/*[in]*/);
}

TOLEBOOL __fastcall TCross::DownLoadResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->DownLoadResult(nJob/*[in]*/);
}

short __fastcall TCross::UpLoad(BSTR strKrcFile/*[in]*/, BSTR strPath/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->UpLoad(strKrcFile/*[in]*/, strPath/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::UpLoadResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->UpLoadResult(nJob/*[in]*/);
}

short __fastcall TCross::UpLoadMem(BSTR strKrcFile/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->UpLoadMem(strKrcFile/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::UpLoadMemResult(short nJob/*[in]*/, BSTR* pbstrMem/*[out]*/)
{
  return GetDefaultInterface()->UpLoadMemResult(nJob/*[in]*/, pbstrMem/*[out]*/);
}

short __fastcall TCross::Delete(BSTR strKrcFile/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->Delete(strKrcFile/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::DeleteResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->DeleteResult(nJob/*[in]*/);
}

short __fastcall TCross::ShowVar(BSTR strVar/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->ShowVar(strVar/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::ShowVarResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/)
{
  return GetDefaultInterface()->ShowVarResult(nJob/*[in]*/, pbstrResult/*[out]*/);
}

short __fastcall TCross::SetVar(BSTR strVar/*[in]*/, BSTR strValue/*[in]*/)
{
  return GetDefaultInterface()->SetVar(strVar/*[in]*/, strValue/*[in]*/);
}

TOLEBOOL __fastcall TCross::SetVarResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->SetVarResult(nJob/*[in]*/);
}

short __fastcall TCross::SetInfo(BSTR strVar/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->SetInfo(strVar/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::SetInfoResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/)
{
  return GetDefaultInterface()->SetInfoResult(nJob/*[in]*/, pbstrResult/*[out]*/);
}

short __fastcall TCross::Run(BSTR strProg/*[in]*/, BSTR strParam/*[in]*/)
{
  return GetDefaultInterface()->Run(strProg/*[in]*/, strParam/*[in]*/);
}

TOLEBOOL __fastcall TCross::RunResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->RunResult(nJob/*[in]*/);
}

short __fastcall TCross::Start(void)
{
  return GetDefaultInterface()->Start();
}

TOLEBOOL __fastcall TCross::StartResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->StartResult(nJob/*[in]*/);
}

short __fastcall TCross::StartOff(void)
{
  return GetDefaultInterface()->StartOff();
}

TOLEBOOL __fastcall TCross::StartOffResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->StartOffResult(nJob/*[in]*/);
}

short __fastcall TCross::Stop(void)
{
  return GetDefaultInterface()->Stop();
}

TOLEBOOL __fastcall TCross::StopResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->StopResult(nJob/*[in]*/);
}

short __fastcall TCross::StopOff(void)
{
  return GetDefaultInterface()->StopOff();
}

TOLEBOOL __fastcall TCross::StopOffResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->StopOffResult(nJob/*[in]*/);
}

short __fastcall TCross::Confirm(short nVerwaltung/*[in]*/)
{
  return GetDefaultInterface()->Confirm(nVerwaltung/*[in]*/);
}

TOLEBOOL __fastcall TCross::ConfirmResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ConfirmResult(nJob/*[in]*/);
}

short __fastcall TCross::GetMessageBuffer(void)
{
  return GetDefaultInterface()->GetMessageBuffer();
}

TOLEBOOL __fastcall TCross::GetMessageBufferResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->GetMessageBufferResult(nJob/*[in]*/);
}

short __fastcall TCross::Reset(void)
{
  return GetDefaultInterface()->Reset();
}

TOLEBOOL __fastcall TCross::ResetResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ResetResult(nJob/*[in]*/);
}

short __fastcall TCross::Cancel(void)
{
  return GetDefaultInterface()->Cancel();
}

TOLEBOOL __fastcall TCross::CancelResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->CancelResult(nJob/*[in]*/);
}

short __fastcall TCross::Select(BSTR strProg/*[in]*/, BSTR strParam/*[in]*/)
{
  return GetDefaultInterface()->Select(strProg/*[in]*/, strParam/*[in]*/);
}

TOLEBOOL __fastcall TCross::SelectResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->SelectResult(nJob/*[in]*/);
}

short __fastcall TCross::Move(short nAxis/*[in]*/, TOLEBOOL bDirection/*[in]*/)
{
  return GetDefaultInterface()->Move(nAxis/*[in]*/, bDirection/*[in]*/);
}

TOLEBOOL __fastcall TCross::MoveResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->MoveResult(nJob/*[in]*/);
}

short __fastcall TCross::MoveOff(short nAxis/*[in]*/, TOLEBOOL bDirection/*[in]*/)
{
  return GetDefaultInterface()->MoveOff(nAxis/*[in]*/, bDirection/*[in]*/);
}

TOLEBOOL __fastcall TCross::MoveOffResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->MoveOffResult(nJob/*[in]*/);
}

short __fastcall TCross::Move6D(void)
{
  return GetDefaultInterface()->Move6D();
}

TOLEBOOL __fastcall TCross::Move6DResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->Move6DResult(nJob/*[in]*/);
}

short __fastcall TCross::Move6DOff(void)
{
  return GetDefaultInterface()->Move6DOff();
}

TOLEBOOL __fastcall TCross::Move6DOffResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->Move6DOffResult(nJob/*[in]*/);
}

short __fastcall TCross::EditOpen(short nModus/*[in]*/, BSTR strFile/*[in]*/)
{
  return GetDefaultInterface()->EditOpen(nModus/*[in]*/, strFile/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditOpenResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditOpenResult(nJob/*[in]*/);
}

short __fastcall TCross::EditClose(short nModus/*[in]*/)
{
  return GetDefaultInterface()->EditClose(nModus/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditCloseResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditCloseResult(nJob/*[in]*/);
}

short __fastcall TCross::EditInsert(short nSatz/*[in]*/, BSTR strDaten/*[in]*/)
{
  return GetDefaultInterface()->EditInsert(nSatz/*[in]*/, strDaten/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditInsertResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditInsertResult(nJob/*[in]*/);
}

short __fastcall TCross::EditChange(short nSatz/*[in]*/, BSTR strDaten/*[in]*/)
{
  return GetDefaultInterface()->EditChange(nSatz/*[in]*/, strDaten/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditChangeResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditChangeResult(nJob/*[in]*/);
}

short __fastcall TCross::EditRedecl(BSTR strDaten/*[in]*/)
{
  return GetDefaultInterface()->EditRedecl(strDaten/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditRedeclResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditRedeclResult(nJob/*[in]*/);
}

short __fastcall TCross::EditDelete(short nSatz/*[in]*/)
{
  return GetDefaultInterface()->EditDelete(nSatz/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditDeleteResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditDeleteResult(nJob/*[in]*/);
}

short __fastcall TCross::Install(void)
{
  return GetDefaultInterface()->Install();
}

TOLEBOOL __fastcall TCross::InstallResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->InstallResult(nJob/*[in]*/);
}

short __fastcall TCross::EndInstall(void)
{
  return GetDefaultInterface()->EndInstall();
}

TOLEBOOL __fastcall TCross::EndInstallResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EndInstallResult(nJob/*[in]*/);
}

short __fastcall TCross::Adjust(short nAxis/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->Adjust(nAxis/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::AdjustResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->AdjustResult(nJob/*[in]*/);
}

short __fastcall TCross::Copy(BSTR strKrcSrc/*[in]*/, BSTR strKRCDest/*[in]*/, BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->Copy(strKrcSrc/*[in]*/, strKRCDest/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::CopyResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->CopyResult(nJob/*[in]*/);
}

short __fastcall TCross::EditPrint(short nSatz/*[in]*/)
{
  return GetDefaultInterface()->EditPrint(nSatz/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditPrintResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/)
{
  return GetDefaultInterface()->EditPrintResult(nJob/*[in]*/, pbstrResult/*[out]*/);
}

short __fastcall TCross::EditDescrMode(short nModus/*[in]*/)
{
  return GetDefaultInterface()->EditDescrMode(nModus/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditDescrModeResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditDescrModeResult(nJob/*[in]*/);
}

TOLEBOOL __fastcall TCross::CmdAbort(short nJob/*[in]*/)
{
  return GetDefaultInterface()->CmdAbort(nJob/*[in]*/);
}

short __fastcall TCross::StopSteu(BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->StopSteu(strOpt/*[in]*/);
}

short __fastcall TCross::CancelSteu(BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->CancelSteu(strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::PHGGet6DMouse(short nJob/*[in]*/, short* pnX/*[out]*/, 
                                          short* pnY/*[out]*/, short* pnZ/*[out]*/, 
                                          short* pnA/*[out]*/, short* pnB/*[out]*/, 
                                          short* pnC/*[out]*/)
{
  return GetDefaultInterface()->PHGGet6DMouse(nJob/*[in]*/, pnX/*[out]*/, pnY/*[out]*/, pnZ/*[out]*/, 
                                              pnA/*[out]*/, pnB/*[out]*/, pnC/*[out]*/);
}

TOLEBOOL __fastcall TCross::RobMoveResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->RobMoveResult(nJob/*[in]*/);
}

short __fastcall TCross::RobMovePTP(BSTR bstrParam/*[in]*/)
{
  return GetDefaultInterface()->RobMovePTP(bstrParam/*[in]*/);
}

short __fastcall TCross::RobMoveLIN(BSTR bstrParam/*[in]*/)
{
  return GetDefaultInterface()->RobMoveLIN(bstrParam/*[in]*/);
}

short __fastcall TCross::RobMovePTP_REL(BSTR bstrParam/*[in]*/)
{
  return GetDefaultInterface()->RobMovePTP_REL(bstrParam/*[in]*/);
}

short __fastcall TCross::RobMoveLIN_REL(BSTR bstrParam/*[in]*/)
{
  return GetDefaultInterface()->RobMoveLIN_REL(bstrParam/*[in]*/);
}

TOLEBOOL __fastcall TCross::KeySwitchResult(short nJob/*[in]*/, short* pnKeySwitchX/*[out]*/)
{
  return GetDefaultInterface()->KeySwitchResult(nJob/*[in]*/, pnKeySwitchX/*[out]*/);
}

short __fastcall TCross::EditMaDaOk(void)
{
  return GetDefaultInterface()->EditMaDaOk();
}

TOLEBOOL __fastcall TCross::EditMaDaOkResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditMaDaOkResult(nJob/*[in]*/);
}

short __fastcall TCross::AkkuOff(void)
{
  return GetDefaultInterface()->AkkuOff();
}

TOLEBOOL __fastcall TCross::AkkuOffResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->AkkuOffResult(nJob/*[in]*/);
}

TOLEBOOL __fastcall TCross::Init(BSTR strMyName/*[in]*/, BSTR strRob/*[in]*/, long nAsync/*[in]*/)
{
  return GetDefaultInterface()->Init(strMyName/*[in]*/, strRob/*[in]*/, nAsync/*[in]*/);
}

TOLEBOOL __fastcall TCross::Exit(void)
{
  return GetDefaultInterface()->Exit();
}

short __fastcall TCross::OCEditInsert(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                      short nSatz/*[in]*/, BSTR strDaten/*[in]*/)
{
  return GetDefaultInterface()->OCEditInsert(nModus/*[in]*/, strFile/*[in]*/, nSatz/*[in]*/, 
                                             strDaten/*[in]*/);
}

TOLEBOOL __fastcall TCross::OCEditInsertResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->OCEditInsertResult(nJob/*[in]*/);
}

short __fastcall TCross::OCEditChange(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                      short nSatz/*[in]*/, BSTR strDaten/*[in]*/)
{
  return GetDefaultInterface()->OCEditChange(nModus/*[in]*/, strFile/*[in]*/, nSatz/*[in]*/, 
                                             strDaten/*[in]*/);
}

TOLEBOOL __fastcall TCross::OCEditChangeResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->OCEditChangeResult(nJob/*[in]*/);
}

short __fastcall TCross::OCEditRedecl(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                      BSTR strDaten/*[in]*/)
{
  return GetDefaultInterface()->OCEditRedecl(nModus/*[in]*/, strFile/*[in]*/, strDaten/*[in]*/);
}

TOLEBOOL __fastcall TCross::OCEditRedeclResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->OCEditRedeclResult(nJob/*[in]*/);
}

short __fastcall TCross::OCEditDelete(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                      short nSatz/*[in]*/)
{
  return GetDefaultInterface()->OCEditDelete(nModus/*[in]*/, strFile/*[in]*/, nSatz/*[in]*/);
}

TOLEBOOL __fastcall TCross::OCEditDeleteResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->OCEditDeleteResult(nJob/*[in]*/);
}

short __fastcall TCross::EditAnalyse(BSTR strFile/*[in]*/)
{
  return GetDefaultInterface()->EditAnalyse(strFile/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditAnalyseResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditAnalyseResult(nJob/*[in]*/);
}

short __fastcall TCross::DPShowVar(BSTR strDataPath/*[in]*/, BSTR strVar/*[in]*/, 
                                   BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->DPShowVar(strDataPath/*[in]*/, strVar/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::DPShowVarResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/)
{
  return GetDefaultInterface()->DPShowVarResult(nJob/*[in]*/, pbstrResult/*[out]*/);
}

short __fastcall TCross::DPSetVar(BSTR strDataPath/*[in]*/, BSTR strVar/*[in]*/, 
                                  BSTR strValue/*[in]*/)
{
  return GetDefaultInterface()->DPSetVar(strDataPath/*[in]*/, strVar/*[in]*/, strValue/*[in]*/);
}

TOLEBOOL __fastcall TCross::DPSetVarResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->DPSetVarResult(nJob/*[in]*/);
}

short __fastcall TCross::IORestart(short nBus/*[in]*/)
{
  return GetDefaultInterface()->IORestart(nBus/*[in]*/);
}

TOLEBOOL __fastcall TCross::IORestartResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->IORestartResult(nJob/*[in]*/);
}

short __fastcall TCross::IOBusInfo(void)
{
  return GetDefaultInterface()->IOBusInfo();
}

TOLEBOOL __fastcall TCross::IOBusInfoResult(short nJob/*[in]*/, long* nBus/*[out]*/)
{
  return GetDefaultInterface()->IOBusInfoResult(nJob/*[in]*/, nBus/*[out]*/);
}

short __fastcall TCross::OCEditDeleteBlock(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                           short nSatz/*[in]*/, short nLines/*[in]*/)
{
  return GetDefaultInterface()->OCEditDeleteBlock(nModus/*[in]*/, strFile/*[in]*/, nSatz/*[in]*/, 
                                                  nLines/*[in]*/);
}

TOLEBOOL __fastcall TCross::OCEditDeleteBlockResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->OCEditDeleteBlockResult(nJob/*[in]*/);
}

short __fastcall TCross::KRCOk(void)
{
  return GetDefaultInterface()->KRCOk();
}

TOLEBOOL __fastcall TCross::KRCOkResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->KRCOkResult(nJob/*[in]*/);
}

TOLEBOOL __fastcall TCross::WriteLogFile(BSTR strFile/*[in]*/)
{
  return GetDefaultInterface()->WriteLogFile(strFile/*[in]*/);
}

TOLEBOOL __fastcall TCross::MeldungFilter(short nMeldung/*[in]*/, TOLEBOOL bAdd/*[in]*/)
{
  return GetDefaultInterface()->MeldungFilter(nMeldung/*[in]*/, bAdd/*[in]*/);
}

TOLEBOOL __fastcall TCross::BOFKeyFilter(short nBOFKey/*[in]*/, TOLEBOOL bAdd/*[in]*/)
{
  return GetDefaultInterface()->BOFKeyFilter(nBOFKey/*[in]*/, bAdd/*[in]*/);
}

short __fastcall TCross::ChangeAccess(BSTR strKrcFile/*[in]*/, BSTR strAccess/*[in]*/)
{
  return GetDefaultInterface()->ChangeAccess(strKrcFile/*[in]*/, strAccess/*[in]*/);
}

TOLEBOOL __fastcall TCross::ChangeAccessResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ChangeAccessResult(nJob/*[in]*/);
}

short __fastcall TCross::ChangeUser(BSTR strKrcFile/*[in]*/, BSTR strUser/*[in]*/)
{
  return GetDefaultInterface()->ChangeUser(strKrcFile/*[in]*/, strUser/*[in]*/);
}

TOLEBOOL __fastcall TCross::ChangeUserResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ChangeUserResult(nJob/*[in]*/);
}

short __fastcall TCross::ChangeComment(BSTR strKrcFile/*[in]*/, BSTR strComment/*[in]*/)
{
  return GetDefaultInterface()->ChangeComment(strKrcFile/*[in]*/, strComment/*[in]*/);
}

TOLEBOOL __fastcall TCross::ChangeCommentResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ChangeCommentResult(nJob/*[in]*/);
}

short __fastcall TCross::EditExec(BSTR strCmdLine/*[in]*/)
{
  return GetDefaultInterface()->EditExec(strCmdLine/*[in]*/);
}

TOLEBOOL __fastcall TCross::EditExecResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->EditExecResult(nJob/*[in]*/);
}

short __fastcall TCross::DisableStart(TOLEBOOL bDisable/*[in]*/, BSTR strErrMsg/*[in]*/)
{
  return GetDefaultInterface()->DisableStart(bDisable/*[in]*/, strErrMsg/*[in]*/);
}

TOLEBOOL __fastcall TCross::DisableStartResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->DisableStartResult(nJob/*[in]*/);
}

TOLEBOOL __fastcall TCross::GetProgressInfo(short nJob/*[in]*/, short* nProgress/*[out]*/, 
                                            BSTR* strInfo/*[out]*/)
{
  return GetDefaultInterface()->GetProgressInfo(nJob/*[in]*/, nProgress/*[out]*/, strInfo/*[out]*/);
}

short __fastcall TCross::GetActiveModule(BSTR strPath/*[in]*/)
{
  return GetDefaultInterface()->GetActiveModule(strPath/*[in]*/);
}

TOLEBOOL __fastcall TCross::GetActiveModuleResult(short nJob/*[in]*/, BSTR* strModule/*[out]*/)
{
  return GetDefaultInterface()->GetActiveModuleResult(nJob/*[in]*/, strModule/*[out]*/);
}

short __fastcall TCross::VolumeGetProp(BSTR strRoot/*[in]*/)
{
  return GetDefaultInterface()->VolumeGetProp(strRoot/*[in]*/);
}

TOLEBOOL __fastcall TCross::VolumeGetPropResult(short nJob/*[in]*/, BSTR* strName/*[out]*/, 
                                                long* eVolumeType/*[out]*/, long* nTotal/*[out]*/, 
                                                long* nFree/*[out]*/, long* nUsed/*[out]*/)
{
  return GetDefaultInterface()->VolumeGetPropResult(nJob/*[in]*/, strName/*[out]*/, 
                                                    eVolumeType/*[out]*/, nTotal/*[out]*/, 
                                                    nFree/*[out]*/, nUsed/*[out]*/);
}

short __fastcall TCross::VolumeSetName(BSTR strRoot/*[in]*/, BSTR strNewName/*[in]*/)
{
  return GetDefaultInterface()->VolumeSetName(strRoot/*[in]*/, strNewName/*[in]*/);
}

TOLEBOOL __fastcall TCross::VolumeSetNameResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->VolumeSetNameResult(nJob/*[in]*/);
}

short __fastcall TCross::VolumeFormat(BSTR strRoot/*[in]*/, BSTR strNewName/*[in]*/, 
                                      TOLEBOOL bQuick/*[in]*/)
{
  return GetDefaultInterface()->VolumeFormat(strRoot/*[in]*/, strNewName/*[in]*/, bQuick/*[in]*/);
}

TOLEBOOL __fastcall TCross::VolumeFormatResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->VolumeFormatResult(nJob/*[in]*/);
}

short __fastcall TCross::VolumeNameList(void)
{
  return GetDefaultInterface()->VolumeNameList();
}

TOLEBOOL __fastcall TCross::VolumeNameListResult(short nJob/*[in]*/, TVariant* astrNames/*[out]*/)
{
  return GetDefaultInterface()->VolumeNameListResult(nJob/*[in]*/, astrNames/*[out]*/);
}

short __fastcall TCross::ItemSetName(BSTR strOldName/*[in]*/, BSTR strNewName/*[in]*/)
{
  return GetDefaultInterface()->ItemSetName(strOldName/*[in]*/, strNewName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemSetNameResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemSetNameResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemSetAttribute(BSTR strName/*[in]*/, long dwAttributes/*[in]*/, 
                                          long dwMask/*[in]*/)
{
  return GetDefaultInterface()->ItemSetAttribute(strName/*[in]*/, dwAttributes/*[in]*/, 
                                                 dwMask/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemSetAttributeResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemSetAttributeResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemNameList(BSTR strName/*[in]*/, long eType/*[in]*/, 
                                      TOLEBOOL bRecursive/*[in]*/)
{
  return GetDefaultInterface()->ItemNameList(strName/*[in]*/, eType/*[in]*/, bRecursive/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemNameListResult(short nJob/*[in]*/, TVariant* astrNames/*[out]*/)
{
  return GetDefaultInterface()->ItemNameListResult(nJob/*[in]*/, astrNames/*[out]*/);
}

short __fastcall TCross::ItemCreate(BSTR strPathName/*[in]*/, BSTR strName/*[in]*/, 
                                    long eType/*[in]*/, long eModulePart/*[in]*/, 
                                    BSTR strTemplate/*[in]*/, long dwCreateFlags/*[in]*/)
{
  return GetDefaultInterface()->ItemCreate(strPathName/*[in]*/, strName/*[in]*/, eType/*[in]*/, 
                                           eModulePart/*[in]*/, strTemplate/*[in]*/, 
                                           dwCreateFlags/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemCreateResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemCreateResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemDestroy(BSTR strName/*[in]*/, long dwDestryFlags/*[in]*/)
{
  return GetDefaultInterface()->ItemDestroy(strName/*[in]*/, dwDestryFlags/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemDestroyResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemDestroyResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemCopy(BSTR strSrcName/*[in]*/, BSTR strDestName/*[in]*/, 
                                  long dwCopyFlags/*[in]*/)
{
  return GetDefaultInterface()->ItemCopy(strSrcName/*[in]*/, strDestName/*[in]*/, 
                                         dwCopyFlags/*[in]*/);
}

short __fastcall TCross::ItemCopySrcMem(TVariant* abSrc/*[in]*/, BSTR strDestName/*[in]*/, 
                                        long dwCopyFlags/*[in]*/)
{
  return GetDefaultInterface()->ItemCopySrcMem(abSrc/*[in]*/, strDestName/*[in]*/, 
                                               dwCopyFlags/*[in]*/);
}

short __fastcall TCross::ItemCopyDestMem(BSTR strSrcName/*[in]*/, long dwCopyFlags/*[in]*/)
{
  return GetDefaultInterface()->ItemCopyDestMem(strSrcName/*[in]*/, dwCopyFlags/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemCopyResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemCopyResult(nJob/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemCopyResultMem(short nJob/*[in]*/, TVariant* abDest/*[out]*/)
{
  return GetDefaultInterface()->ItemCopyResultMem(nJob/*[in]*/, abDest/*[out]*/);
}

short __fastcall TCross::ItemMove(BSTR strSrcName/*[in]*/, BSTR strDestName/*[in]*/, 
                                  long dwCopyFlags/*[in]*/)
{
  return GetDefaultInterface()->ItemMove(strSrcName/*[in]*/, strDestName/*[in]*/, 
                                         dwCopyFlags/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemMoveResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemMoveResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemCompare(BSTR strSrcName/*[in]*/, BSTR strDestName/*[in]*/)
{
  return GetDefaultInterface()->ItemCompare(strSrcName/*[in]*/, strDestName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemCompareResult(short nJob/*[in]*/, TOLEBOOL* bEqual/*[out]*/)
{
  return GetDefaultInterface()->ItemCompareResult(nJob/*[in]*/, bEqual/*[out]*/);
}

TOLEBOOL __fastcall TCross::ItemSelectResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemSelectResult(nJob/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemRunResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemRunResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemReset(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ItemReset(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemResetResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemResetResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemStart(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ItemStart(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemStartResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemStartResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemStop(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ItemStop(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemStopResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemStopResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemCancel(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ItemCancel(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemCancelResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemCancelResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemAnalyse(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ItemAnalyse(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemAnalyseResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemAnalyseResult(nJob/*[in]*/);
}

short __fastcall TCross::ModuleCodeGetProp(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeGetProp(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeGetPropResult(short nJob/*[in]*/, long* nLines/*[out]*/, 
                                                    long* eCodeType/*[out]*/)
{
  return GetDefaultInterface()->ModuleCodeGetPropResult(nJob/*[in]*/, nLines/*[out]*/, 
                                                        eCodeType/*[out]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeOpenResult(short nJob/*[in]*/, long* nHandle/*[out]*/)
{
  return GetDefaultInterface()->ModuleCodeOpenResult(nJob/*[in]*/, nHandle/*[out]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeCloseResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeCloseResult(nJob/*[in]*/);
}

short __fastcall TCross::ModuleCodeGetLines(long nHandle/*[in]*/, long nStart/*[in]*/, 
                                            long nCount/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeGetLines(nHandle/*[in]*/, nStart/*[in]*/, nCount/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeGetLinesResult(short nJob/*[in]*/, 
                                                     TVariant* astrLines/*[out]*/)
{
  return GetDefaultInterface()->ModuleCodeGetLinesResult(nJob/*[in]*/, astrLines/*[out]*/);
}

short __fastcall TCross::ModuleCodeInsertLines(long nHandle/*[in]*/, long nStart/*[in]*/, 
                                               TVariant* astrLines/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeInsertLines(nHandle/*[in]*/, nStart/*[in]*/, 
                                                      astrLines/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeInsertLinesResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeInsertLinesResult(nJob/*[in]*/);
}

short __fastcall TCross::ModuleCodeDeleteLines(long nHandle/*[in]*/, long nStart/*[in]*/, 
                                               long nCount/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeDeleteLines(nHandle/*[in]*/, nStart/*[in]*/, 
                                                      nCount/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeDeleteLinesResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeDeleteLinesResult(nJob/*[in]*/);
}

short __fastcall TCross::ModuleCodeReplaceLines(long nHandle/*[in]*/, long nStart/*[in]*/, 
                                                long nCount/*[in]*/, TVariant* astrNewLines/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeReplaceLines(nHandle/*[in]*/, nStart/*[in]*/, 
                                                       nCount/*[in]*/, astrNewLines/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeReplaceLinesResult(short nJob/*[in]*/, 
                                                         TVariant* astrOldLines/*[out]*/)
{
  return GetDefaultInterface()->ModuleCodeReplaceLinesResult(nJob/*[in]*/, astrOldLines/*[out]*/);
}

short __fastcall TCross::ModuleCodeRedeclare(long nHandle/*[in]*/, BSTR strName/*[in]*/, 
                                             BSTR strType/*[in]*/, BSTR strValue/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeRedeclare(nHandle/*[in]*/, strName/*[in]*/, 
                                                    strType/*[in]*/, strValue/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeRedeclareResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeRedeclareResult(nJob/*[in]*/);
}

short __fastcall TCross::ModuleCodeFind(long nHandle/*[in]*/, BSTR strFind/*[in]*/, 
                                        long nStartLine/*[in]*/, long nStartColumn/*[in]*/, 
                                        long nEndLine/*[in]*/, long nEndColumn/*[in]*/, 
                                        TOLEBOOL bWord/*[in]*/, TOLEBOOL bMatchCase/*[in]*/, 
                                        TOLEBOOL bSearchRevers/*[in]*/, TOLEBOOL bPattern/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeFind(nHandle/*[in]*/, strFind/*[in]*/, nStartLine/*[in]*/, 
                                               nStartColumn/*[in]*/, nEndLine/*[in]*/, 
                                               nEndColumn/*[in]*/, bWord/*[in]*/, bMatchCase/*[in]*/, 
                                               bSearchRevers/*[in]*/, bPattern/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeFindResult(short nJob/*[in]*/, long* nStartLine/*[out]*/, 
                                                 long* nStartColumn/*[out]*/, 
                                                 long* nEndLine/*[out]*/, long* nEndColumn/*[out]*/)
{
  return GetDefaultInterface()->ModuleCodeFindResult(nJob/*[in]*/, nStartLine/*[out]*/, 
                                                     nStartColumn/*[out]*/, nEndLine/*[out]*/, 
                                                     nEndColumn/*[out]*/);
}

short __fastcall TCross::ModuleCodeFindStruct(long nHandle/*[in]*/, long nLine/*[in]*/, 
                                              long eStructKind/*[in]*/, TOLEBOOL bStart/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeFindStruct(nHandle/*[in]*/, nLine/*[in]*/, 
                                                     eStructKind/*[in]*/, bStart/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeFindStructResult(short nJob/*[in]*/, long* nLine/*[out]*/, 
                                                       long* eStructKind/*[out]*/, 
                                                       BSTR* strStruct/*[out]*/)
{
  return GetDefaultInterface()->ModuleCodeFindStructResult(nJob/*[in]*/, nLine/*[out]*/, 
                                                           eStructKind/*[out]*/, strStruct/*[out]*/);
}

short __fastcall TCross::ModuleCodeSelectLine(long nHandle/*[in]*/, long nLine/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeSelectLine(nHandle/*[in]*/, nLine/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeSelectLineResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeSelectLineResult(nJob/*[in]*/);
}

short __fastcall TCross::ErrorGetProp(BSTR strName/*[in]*/, long nIndex/*[in]*/)
{
  return GetDefaultInterface()->ErrorGetProp(strName/*[in]*/, nIndex/*[in]*/);
}

TOLEBOOL __fastcall TCross::ErrorGetPropResult(short nJob/*[in]*/, BSTR* strModule/*[out]*/, 
                                               long* nLine/*[out]*/, long* nColumn/*[out]*/, 
                                               long* nError/*[out]*/, BSTR* strParam/*[out]*/)
{
  return GetDefaultInterface()->ErrorGetPropResult(nJob/*[in]*/, strModule/*[out]*/, nLine/*[out]*/, 
                                                   nColumn/*[out]*/, nError/*[out]*/, 
                                                   strParam/*[out]*/);
}

short __fastcall TCross::ErrorList(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ErrorList(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ErrorListResult(short nJob/*[in]*/, TVariant* astrModules/*[out]*/, 
                                            TVariant* anLine/*[out]*/, TVariant* anColumn/*[out]*/, 
                                            TVariant* anError/*[out]*/, 
                                            TVariant* astrParams/*[out]*/)
{
  return GetDefaultInterface()->ErrorListResult(nJob/*[in]*/, astrModules/*[out]*/, anLine/*[out]*/, 
                                                anColumn/*[out]*/, anError/*[out]*/, 
                                                astrParams/*[out]*/);
}

short __fastcall TCross::ModuleInformationGetProp(BSTR strName/*[in]*/, long dwMask/*[in]*/)
{
  return GetDefaultInterface()->ModuleInformationGetProp(strName/*[in]*/, dwMask/*[in]*/);
}

short __fastcall TCross::ModuleInformationSetProp(BSTR strName/*[in]*/, long dwMask/*[in]*/, 
                                                  TOLEBOOL bVisible/*[in]*/, 
                                                  TOLEBOOL bReadable/*[in]*/, BSTR strUser/*[in]*/, 
                                                  BSTR strComment/*[in]*/)
{
  return GetDefaultInterface()->ModuleInformationSetProp(strName/*[in]*/, dwMask/*[in]*/, 
                                                         bVisible/*[in]*/, bReadable/*[in]*/, 
                                                         strUser/*[in]*/, strComment/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleInformationSetPropResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ModuleInformationSetPropResult(nJob/*[in]*/);
}

short __fastcall TCross::ModuleInformationGetUserAttribute(BSTR strName/*[in]*/, 
                                                           BSTR strAttrib/*[in]*/)
{
  return GetDefaultInterface()->ModuleInformationGetUserAttribute(strName/*[in]*/, strAttrib/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleInformationGetUserAttributeResult(short nJob/*[in]*/, 
                                                                    BSTR* strValue/*[out]*/)
{
  return GetDefaultInterface()->ModuleInformationGetUserAttributeResult(nJob/*[in]*/, 
                                                                        strValue/*[out]*/);
}

short __fastcall TCross::ModuleInformationSetUserAttribute(BSTR strName/*[in]*/, 
                                                           BSTR strAttrib/*[in]*/, 
                                                           BSTR strValue/*[in]*/)
{
  return GetDefaultInterface()->ModuleInformationSetUserAttribute(strName/*[in]*/, strAttrib/*[in]*/, 
                                                                  strValue/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleInformationSetUserAttributeResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ModuleInformationSetUserAttributeResult(nJob/*[in]*/);
}

short __fastcall TCross::ModuleInformationUserAttributesList(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ModuleInformationUserAttributesList(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleInformationUserAttributesListResult(short nJob/*[in]*/, 
                                                                      TVariant* astrNames/*[out]*/, 
                                                                      TVariant* astrValues/*[out]*/)
{
  return GetDefaultInterface()->ModuleInformationUserAttributesListResult(nJob/*[in]*/, 
                                                                          astrNames/*[out]*/, 
                                                                          astrValues/*[out]*/);
}

short __fastcall TCross::ModuleDependenciesList(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ModuleDependenciesList(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleDependenciesListResult(short nJob/*[in]*/, 
                                                         TVariant* astrDependencies/*[out]*/)
{
  return GetDefaultInterface()->ModuleDependenciesListResult(nJob/*[in]*/, astrDependencies/*[out]*/);
}

TOLEBOOL __fastcall TCross::NotifyVolumeResult(short nJob/*[in]*/, long* dwChanged/*[out]*/)
{
  return GetDefaultInterface()->NotifyVolumeResult(nJob/*[in]*/, dwChanged/*[out]*/);
}

TOLEBOOL __fastcall TCross::NotifyItemResult(short nJob/*[in]*/, long* dwChanged/*[out]*/)
{
  return GetDefaultInterface()->NotifyItemResult(nJob/*[in]*/, dwChanged/*[out]*/);
}

TOLEBOOL __fastcall TCross::NotifyModuleInformationResult(short nJob/*[in]*/, 
                                                          long* dwChanged/*[out]*/)
{
  return GetDefaultInterface()->NotifyModuleInformationResult(nJob/*[in]*/, dwChanged/*[out]*/);
}

TOLEBOOL __fastcall TCross::NotifyModuleCodeResult(short nJob/*[in]*/, long* dwChanged/*[out]*/)
{
  return GetDefaultInterface()->NotifyModuleCodeResult(nJob/*[in]*/, dwChanged/*[out]*/);
}

short __fastcall TCross::ItemGetProp(BSTR strName/*[in]*/, long dwMask/*[in]*/)
{
  return GetDefaultInterface()->ItemGetProp(strName/*[in]*/, dwMask/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemGetPropResult(short nJob/*[in]*/, long* eItemType/*[out]*/, 
                                              BSTR* strName/*[out]*/, long* dwSize/*[out]*/, 
                                              long* dwAttributes/*[out]*/, 
                                              DATE* pdateTimeCreated/*[out]*/, 
                                              DATE* pdateTimeAccess/*[out]*/, 
                                              DATE* pdateTimeModified/*[out]*/, 
                                              long* eEditMode/*[out]*/)
{
  return GetDefaultInterface()->ItemGetPropResult(nJob/*[in]*/, eItemType/*[out]*/, strName/*[out]*/, 
                                                  dwSize/*[out]*/, dwAttributes/*[out]*/, 
                                                  pdateTimeCreated/*[out]*/, 
                                                  pdateTimeAccess/*[out]*/, 
                                                  pdateTimeModified/*[out]*/, eEditMode/*[out]*/);
}

short __fastcall TCross::ItemSelect(BSTR strName/*[in]*/, BSTR strParams/*[in]*/, 
                                    long dwOptions/*[in]*/)
{
  return GetDefaultInterface()->ItemSelect(strName/*[in]*/, strParams/*[in]*/, dwOptions/*[in]*/);
}

short __fastcall TCross::ItemRun(BSTR strName/*[in]*/, BSTR strParams/*[in]*/, 
                                 long dwOptions/*[in]*/)
{
  return GetDefaultInterface()->ItemRun(strName/*[in]*/, strParams/*[in]*/, dwOptions/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleInformationGetPropResult(short nJob/*[in]*/, 
                                                           long* eSourceType/*[out]*/, 
                                                           long* nDataSize/*[out]*/, 
                                                           long* nSourceSize/*[out]*/, 
                                                           long* nSonCounter/*[out]*/, 
                                                           long* nRelease/*[out]*/, 
                                                           TOLEBOOL* bPredefined/*[out]*/, 
                                                           TOLEBOOL* bOldParent/*[out]*/, 
                                                           TOLEBOOL* bParent/*[out]*/, 
                                                           TOLEBOOL* bVisible/*[out]*/, 
                                                           TOLEBOOL* bReadable/*[out]*/, 
                                                           TOLEBOOL* bErrors/*[out]*/, 
                                                           TOLEBOOL* bChanged/*[out]*/, 
                                                           TOLEBOOL* bHasData/*[out]*/, 
                                                           BSTR* strUser/*[out]*/, 
                                                           BSTR* strComment/*[out]*/, 
                                                           long* eItemState0/*[out]*/, 
                                                           long* eItemState1/*[out]*/)
{
  return GetDefaultInterface()->ModuleInformationGetPropResult(nJob/*[in]*/, eSourceType/*[out]*/, 
                                                               nDataSize/*[out]*/, 
                                                               nSourceSize/*[out]*/, 
                                                               nSonCounter/*[out]*/, 
                                                               nRelease/*[out]*/, 
                                                               bPredefined/*[out]*/, 
                                                               bOldParent/*[out]*/, bParent/*[out]*/, 
                                                               bVisible/*[out]*/, bReadable/*[out]*/, 
                                                               bErrors/*[out]*/, bChanged/*[out]*/, 
                                                               bHasData/*[out]*/, strUser/*[out]*/, 
                                                               strComment/*[out]*/, 
                                                               eItemState0/*[out]*/, 
                                                               eItemState1/*[out]*/);
}

short __fastcall TCross::NotifyVolume(BSTR strRoot/*[in]*/, long dwMask/*[in]*/, 
                                      long lMinRecTime/*[in]*/)
{
  return GetDefaultInterface()->NotifyVolume(strRoot/*[in]*/, dwMask/*[in]*/, lMinRecTime/*[in]*/);
}

short __fastcall TCross::NotifyItem(BSTR strName/*[in]*/, long* dwMask/*[out]*/, 
                                    long lMinRecTime/*[in]*/)
{
  return GetDefaultInterface()->NotifyItem(strName/*[in]*/, dwMask/*[out]*/, lMinRecTime/*[in]*/);
}

short __fastcall TCross::NotifyModuleInformation(BSTR strName/*[in]*/, long* dwMask/*[out]*/, 
                                                 long lMinRecTime/*[in]*/)
{
  return GetDefaultInterface()->NotifyModuleInformation(strName/*[in]*/, dwMask/*[out]*/, 
                                                        lMinRecTime/*[in]*/);
}

short __fastcall TCross::NotifyModuleCode(BSTR strName/*[in]*/, long* dwMask/*[out]*/, 
                                          long lMinRecTime/*[in]*/)
{
  return GetDefaultInterface()->NotifyModuleCode(strName/*[in]*/, dwMask/*[out]*/, 
                                                 lMinRecTime/*[in]*/);
}

short __fastcall TCross::GetFullName(BSTR strKRCName/*[in]*/)
{
  return GetDefaultInterface()->GetFullName(strKRCName/*[in]*/);
}

TOLEBOOL __fastcall TCross::GetFullNameResult(short nJob/*[in]*/, BSTR* strFullName/*[out]*/)
{
  return GetDefaultInterface()->GetFullNameResult(nJob/*[in]*/, strFullName/*[out]*/);
}

short __fastcall TCross::GetKRCName(BSTR strFullName/*[in]*/)
{
  return GetDefaultInterface()->GetKRCName(strFullName/*[in]*/);
}

TOLEBOOL __fastcall TCross::GetKRCNameResult(short nJob/*[in]*/, BSTR* strKRCName/*[out]*/)
{
  return GetDefaultInterface()->GetKRCNameResult(nJob/*[in]*/, strKRCName/*[out]*/);
}

short __fastcall TCross::AnalyseMode(long bAll/*[in]*/)
{
  return GetDefaultInterface()->AnalyseMode(bAll/*[in]*/);
}

TOLEBOOL __fastcall TCross::AnalyseModeResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->AnalyseModeResult(nJob/*[in]*/);
}

short __fastcall TCross::FlushLog(void)
{
  return GetDefaultInterface()->FlushLog();
}

TOLEBOOL __fastcall TCross::FlushLogResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->FlushLogResult(nJob/*[in]*/);
}

short __fastcall TCross::GetLogHeader(void)
{
  return GetDefaultInterface()->GetLogHeader();
}

TOLEBOOL __fastcall TCross::GetLogHeaderResult(short nJob/*[in]*/, TVariant* astrHeader/*[out]*/)
{
  return GetDefaultInterface()->GetLogHeaderResult(nJob/*[in]*/, astrHeader/*[out]*/);
}

short __fastcall TCross::ModuleCodeOpen(BSTR strName/*[in]*/, long dwMode/*[in]*/, 
                                        long dwEditMode/*[in]*/, BSTR strModule/*[in]*/, 
                                        BSTR strErrorKey/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeOpen(strName/*[in]*/, dwMode/*[in]*/, dwEditMode/*[in]*/, 
                                               strModule/*[in]*/, strErrorKey/*[in]*/);
}

short __fastcall TCross::ModuleCodeClose(long nHandle/*[in]*/, TOLEBOOL bSave/*[in]*/, 
                                         long dwEditMode/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeClose(nHandle/*[in]*/, bSave/*[in]*/, dwEditMode/*[in]*/);
}

short __fastcall TCross::GetActiveInterface(void)
{
  return GetDefaultInterface()->GetActiveInterface();
}

TOLEBOOL __fastcall TCross::GetActiveInterfaceResult(short nJob/*[in]*/, TOLEBOOL* bActive/*[out]*/)
{
  return GetDefaultInterface()->GetActiveInterfaceResult(nJob/*[in]*/, bActive/*[out]*/);
}

short __fastcall TCross::SetActiveInterface(void)
{
  return GetDefaultInterface()->SetActiveInterface();
}

TOLEBOOL __fastcall TCross::SetActiveInterfaceResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->SetActiveInterfaceResult(nJob/*[in]*/);
}

short __fastcall TCross::NotifyActiveInterface(void)
{
  return GetDefaultInterface()->NotifyActiveInterface();
}

TOLEBOOL __fastcall TCross::NotifyActiveInterfaceResult(short nJob/*[in]*/, 
                                                        TOLEBOOL* bActive/*[out]*/)
{
  return GetDefaultInterface()->NotifyActiveInterfaceResult(nJob/*[in]*/, bActive/*[out]*/);
}

short __fastcall TCross::DPSetInfo(BSTR strDataPath/*[in]*/, BSTR strVar/*[in]*/, 
                                   BSTR strOpt/*[in]*/)
{
  return GetDefaultInterface()->DPSetInfo(strDataPath/*[in]*/, strVar/*[in]*/, strOpt/*[in]*/);
}

TOLEBOOL __fastcall TCross::DPSetInfoResult(short nJob/*[in]*/, BSTR* pbstrResult/*[out]*/)
{
  return GetDefaultInterface()->DPSetInfoResult(nJob/*[in]*/, pbstrResult/*[out]*/);
}

short __fastcall TCross::ItemLink(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ItemLink(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemLinkResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemLinkResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemUnlink(BSTR strName/*[in]*/)
{
  return GetDefaultInterface()->ItemUnlink(strName/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemUnlinkResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->ItemUnlinkResult(nJob/*[in]*/);
}

short __fastcall TCross::ModuleCodeReOpen(long nHandle/*[in]*/, long dwMode/*[in]*/, 
                                          long dwEditMode/*[in]*/, BSTR strModule/*[in]*/, 
                                          BSTR strErrorKey/*[in]*/)
{
  return GetDefaultInterface()->ModuleCodeReOpen(nHandle/*[in]*/, dwMode/*[in]*/, dwEditMode/*[in]*/, 
                                                 strModule/*[in]*/, strErrorKey/*[in]*/);
}

TOLEBOOL __fastcall TCross::ModuleCodeReOpenResult(short nJob/*[in]*/, long* nHandle/*[out]*/)
{
  return GetDefaultInterface()->ModuleCodeReOpenResult(nJob/*[in]*/, nHandle/*[out]*/);
}

short __fastcall TCross::VxWinGetConfig(void)
{
  return GetDefaultInterface()->VxWinGetConfig();
}

TOLEBOOL __fastcall TCross::VxWinGetConfigResult(short nJob/*[in]*/, TOLEBOOL* pbForceCold/*[out]*/)
{
  return GetDefaultInterface()->VxWinGetConfigResult(nJob/*[in]*/, pbForceCold/*[out]*/);
}

short __fastcall TCross::VxWinSetConfig(TOLEBOOL bForceCold/*[in]*/)
{
  return GetDefaultInterface()->VxWinSetConfig(bForceCold/*[in]*/);
}

TOLEBOOL __fastcall TCross::VxWinSetConfigResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->VxWinSetConfigResult(nJob/*[in]*/);
}

short __fastcall TCross::LogGetConfig(void)
{
  return GetDefaultInterface()->LogGetConfig();
}

TOLEBOOL __fastcall TCross::LogGetConfigResult(short nJob/*[in]*/, long* pnMaxEntries/*[out]*/)
{
  return GetDefaultInterface()->LogGetConfigResult(nJob/*[in]*/, pnMaxEntries/*[out]*/);
}

short __fastcall TCross::LogSetConfig(long nMaxEntries/*[in]*/)
{
  return GetDefaultInterface()->LogSetConfig(nMaxEntries/*[in]*/);
}

TOLEBOOL __fastcall TCross::LogSetConfigResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->LogSetConfigResult(nJob/*[in]*/);
}

short __fastcall TCross::ItemGetCRC(BSTR strName/*[in]*/, TOLEBOOL bBinary/*[in]*/)
{
  return GetDefaultInterface()->ItemGetCRC(strName/*[in]*/, bBinary/*[in]*/);
}

TOLEBOOL __fastcall TCross::ItemGetCRCResult(short nJob/*[in]*/, long* pdwCRC/*[out]*/)
{
  return GetDefaultInterface()->ItemGetCRCResult(nJob/*[in]*/, pdwCRC/*[out]*/);
}

short __fastcall TCross::OCEditInsertBlock(short nModus/*[in]*/, BSTR strFile/*[in]*/, 
                                           short nStart/*[in]*/, TVariant* astrLines/*[in]*/)
{
  return GetDefaultInterface()->OCEditInsertBlock(nModus/*[in]*/, strFile/*[in]*/, nStart/*[in]*/, 
                                                  astrLines/*[in]*/);
}

TOLEBOOL __fastcall TCross::OCEditInsertBlockResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->OCEditInsertBlockResult(nJob/*[in]*/);
}

short __fastcall TCross::LogAddItem(BSTR strSource/*[in]*/, BSTR strInstance/*[in]*/, 
                                    long nMessage/*[in]*/, short nLogLevel/*[in]*/, 
                                    BSTR strDBModule/*[in]*/, BSTR strDBKey/*[in]*/, 
                                    BSTR strDBShortKey/*[in]*/, TVariant* astrParams/*[in]*/, 
                                    TVariant* abDBParams/*[in]*/, BSTR strOptional/*[in]*/, 
                                    long eLogClass/*[in]*/, long eLogType/*[in]*/)
{
  return GetDefaultInterface()->LogAddItem(strSource/*[in]*/, strInstance/*[in]*/, nMessage/*[in]*/, 
                                           nLogLevel/*[in]*/, strDBModule/*[in]*/, strDBKey/*[in]*/, 
                                           strDBShortKey/*[in]*/, astrParams/*[in]*/, 
                                           abDBParams/*[in]*/, strOptional/*[in]*/, 
                                           eLogClass/*[in]*/, eLogType/*[in]*/);
}

TOLEBOOL __fastcall TCross::LogAddItemResult(short nJob/*[in]*/, long* pnLogNumber/*[out]*/)
{
  return GetDefaultInterface()->LogAddItemResult(nJob/*[in]*/, pnLogNumber/*[out]*/);
}

short __fastcall TCross::LogOCGetItem(long nFirst/*[in]*/)
{
  return GetDefaultInterface()->LogOCGetItem(nFirst/*[in]*/);
}

TOLEBOOL __fastcall TCross::LogOCGetItemResult(short nJob/*[in]*/, long* pnActItems/*[out]*/, 
                                               DATE* pdateTimeStamp/*[out]*/, 
                                               short* pnMilliseconds/*[out]*/, 
                                               long* pnLogNumber/*[out]*/, 
                                               BSTR* pbstrSource/*[out]*/, 
                                               BSTR* pbstrInstance/*[out]*/, 
                                               long* pnMessage/*[out]*/, short* pnLogLevel/*[out]*/, 
                                               BSTR* pbstrDBModule/*[out]*/, 
                                               BSTR* pbstrDBKey/*[out]*/, 
                                               BSTR* pbstrDBShortKey/*[out]*/, 
                                               TVariant* pastrParams/*[out]*/, 
                                               TVariant* pabDBParams/*[out]*/, 
                                               BSTR* pbstrOptional/*[out]*/, 
                                               long* peLogClass/*[out]*/, long* peLogType/*[out]*/)
{
  return GetDefaultInterface()->LogOCGetItemResult(nJob/*[in]*/, pnActItems/*[out]*/, 
                                                   pdateTimeStamp/*[out]*/, pnMilliseconds/*[out]*/, 
                                                   pnLogNumber/*[out]*/, pbstrSource/*[out]*/, 
                                                   pbstrInstance/*[out]*/, pnMessage/*[out]*/, 
                                                   pnLogLevel/*[out]*/, pbstrDBModule/*[out]*/, 
                                                   pbstrDBKey/*[out]*/, pbstrDBShortKey/*[out]*/, 
                                                   pastrParams/*[out]*/, pabDBParams/*[out]*/, 
                                                   pbstrOptional/*[out]*/, peLogClass/*[out]*/, 
                                                   peLogType/*[out]*/);
}

short __fastcall TCross::LogOpen(long dwFilter/*[in]*/)
{
  return GetDefaultInterface()->LogOpen(dwFilter/*[in]*/);
}

TOLEBOOL __fastcall TCross::LogOpenResult(short nJob/*[in]*/, long* pdwHandle/*[out]*/)
{
  return GetDefaultInterface()->LogOpenResult(nJob/*[in]*/, pdwHandle/*[out]*/);
}

short __fastcall TCross::LogClose(long dwHandle/*[in]*/)
{
  return GetDefaultInterface()->LogClose(dwHandle/*[in]*/);
}

TOLEBOOL __fastcall TCross::LogCloseResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->LogCloseResult(nJob/*[in]*/);
}

short __fastcall TCross::LogGetItem(long dwHandle/*[in]*/, long nFirst/*[in]*/, 
                                    TOLEBOOL bUseBookmark/*[in]*/)
{
  return GetDefaultInterface()->LogGetItem(dwHandle/*[in]*/, nFirst/*[in]*/, bUseBookmark/*[in]*/);
}

TOLEBOOL __fastcall TCross::LogGetItemResult(short nJob/*[in]*/, long* pnActItems/*[out]*/, 
                                             DATE* pdateTimeStamp/*[out]*/, 
                                             short* pnMilliseconds/*[out]*/, 
                                             long* pnLogNumber/*[out]*/, BSTR* pbstrSource/*[out]*/, 
                                             BSTR* pbstrInstance/*[out]*/, long* pnMessage/*[out]*/, 
                                             short* pnLogLevel/*[out]*/, 
                                             BSTR* pbstrDBModule/*[out]*/, BSTR* pbstrDBKey/*[out]*/, 
                                             BSTR* pbstrDBShortKey/*[out]*/, 
                                             TVariant* pastrParams/*[out]*/, 
                                             TVariant* pabDBParams/*[out]*/, 
                                             BSTR* pbstrOptional/*[out]*/, long* peLogClass/*[out]*/, 
                                             long* peLogType/*[out]*/)
{
  return GetDefaultInterface()->LogGetItemResult(nJob/*[in]*/, pnActItems/*[out]*/, 
                                                 pdateTimeStamp/*[out]*/, pnMilliseconds/*[out]*/, 
                                                 pnLogNumber/*[out]*/, pbstrSource/*[out]*/, 
                                                 pbstrInstance/*[out]*/, pnMessage/*[out]*/, 
                                                 pnLogLevel/*[out]*/, pbstrDBModule/*[out]*/, 
                                                 pbstrDBKey/*[out]*/, pbstrDBShortKey/*[out]*/, 
                                                 pastrParams/*[out]*/, pabDBParams/*[out]*/, 
                                                 pbstrOptional/*[out]*/, peLogClass/*[out]*/, 
                                                 peLogType/*[out]*/);
}

short __fastcall TCross::LogExport(BSTR strFileName/*[in]*/, long eExport/*[in]*/, 
                                   long dwFilter/*[in]*/)
{
  return GetDefaultInterface()->LogExport(strFileName/*[in]*/, eExport/*[in]*/, dwFilter/*[in]*/);
}

TOLEBOOL __fastcall TCross::LogExportResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->LogExportResult(nJob/*[in]*/);
}

short __fastcall TCross::LogPrint(long dwFilter/*[in]*/)
{
  return GetDefaultInterface()->LogPrint(dwFilter/*[in]*/);
}

TOLEBOOL __fastcall TCross::LogPrintResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->LogPrintResult(nJob/*[in]*/);
}

TOLEBOOL __fastcall TCross::GetSyncAddMessage(short nJob/*[in]*/, 
                                              Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                              long* pdwMsgHandle/*[out]*/, 
                                              long* peMessageType/*[out]*/, 
                                              long* pdwMessage/*[out]*/, 
                                              BSTR* pbstrDBModule/*[out]*/, 
                                              BSTR* pbstrDBCause/*[out]*/, 
                                              BSTR* pbstrDBMessage/*[out]*/, 
                                              TVariant* astrParams/*[out]*/, 
                                              TVariant* abDBParams/*[out]*/)
{
  return GetDefaultInterface()->GetSyncAddMessage(nJob/*[in]*/, ppTime/*[in,out]*/, 
                                                  pdwMsgHandle/*[out]*/, peMessageType/*[out]*/, 
                                                  pdwMessage/*[out]*/, pbstrDBModule/*[out]*/, 
                                                  pbstrDBCause/*[out]*/, pbstrDBMessage/*[out]*/, 
                                                  astrParams/*[out]*/, abDBParams/*[out]*/);
}

TOLEBOOL __fastcall TCross::GetSyncAddDialog(short nJob/*[in]*/, 
                                             Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                             long* pdwMsgHandle/*[out]*/, 
                                             long* peMessageType/*[out]*/, long* pdwMessage/*[out]*/, 
                                             BSTR* pbstrDBModule/*[out]*/, 
                                             BSTR* pbstrDBCause/*[out]*/, 
                                             BSTR* pbstrDBMessage/*[out]*/, 
                                             TVariant* astrParams/*[out]*/, 
                                             TVariant* abDBParams/*[out]*/, 
                                             TVariant* astrAnswers/*[out]*/, 
                                             TVariant* abDBAnswers/*[out]*/)
{
  return GetDefaultInterface()->GetSyncAddDialog(nJob/*[in]*/, ppTime/*[in,out]*/, 
                                                 pdwMsgHandle/*[out]*/, peMessageType/*[out]*/, 
                                                 pdwMessage/*[out]*/, pbstrDBModule/*[out]*/, 
                                                 pbstrDBCause/*[out]*/, pbstrDBMessage/*[out]*/, 
                                                 astrParams/*[out]*/, abDBParams/*[out]*/, 
                                                 astrAnswers/*[out]*/, abDBAnswers/*[out]*/);
}

TOLEBOOL __fastcall TCross::SyncAnswer(short nJob/*[in]*/, long dwMsgHandle/*[in]*/, 
                                       short nAnswer/*[in]*/)
{
  return GetDefaultInterface()->SyncAnswer(nJob/*[in]*/, dwMsgHandle/*[in]*/, nAnswer/*[in]*/);
}

TOLEBOOL __fastcall TCross::GetAsyncAddMessage(short nAsync/*[in]*/, 
                                               Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                               long* pdwMsgHandle/*[out]*/, 
                                               long* peMessageType/*[out]*/, 
                                               long* pdwMessage/*[out]*/, 
                                               BSTR* pbstrDBModule/*[out]*/, 
                                               BSTR* pbstrDBCause/*[out]*/, 
                                               BSTR* pbstrDBMessage/*[out]*/, 
                                               TVariant* astrParams/*[out]*/, 
                                               TVariant* abDBParams/*[out]*/)
{
  return GetDefaultInterface()->GetAsyncAddMessage(nAsync/*[in]*/, ppTime/*[in,out]*/, 
                                                   pdwMsgHandle/*[out]*/, peMessageType/*[out]*/, 
                                                   pdwMessage/*[out]*/, pbstrDBModule/*[out]*/, 
                                                   pbstrDBCause/*[out]*/, pbstrDBMessage/*[out]*/, 
                                                   astrParams/*[out]*/, abDBParams/*[out]*/);
}

TOLEBOOL __fastcall TCross::GetAsyncAddDialog(short nAsync/*[in]*/, 
                                              Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                              long* pdwMsgHandle/*[out]*/, 
                                              long* peMessageType/*[out]*/, 
                                              long* pdwMessage/*[out]*/, 
                                              BSTR* pbstrDBModule/*[out]*/, 
                                              BSTR* pbstrDBCause/*[out]*/, 
                                              BSTR* pbstrDBMessage/*[out]*/, 
                                              TVariant* astrParams/*[out]*/, 
                                              TVariant* abDBParams/*[out]*/, 
                                              TVariant* astrAnswers/*[out]*/, 
                                              TVariant* abDBAnswers/*[out]*/)
{
  return GetDefaultInterface()->GetAsyncAddDialog(nAsync/*[in]*/, ppTime/*[in,out]*/, 
                                                  pdwMsgHandle/*[out]*/, peMessageType/*[out]*/, 
                                                  pdwMessage/*[out]*/, pbstrDBModule/*[out]*/, 
                                                  pbstrDBCause/*[out]*/, pbstrDBMessage/*[out]*/, 
                                                  astrParams/*[out]*/, abDBParams/*[out]*/, 
                                                  astrAnswers/*[out]*/, abDBAnswers/*[out]*/);
}

TOLEBOOL __fastcall TCross::GetAsyncSubMessage(short nAsync/*[in]*/, 
                                               Wbf_timelib_tlb::IFileTimePtr* ppTime/*[in,out]*/, 
                                               long* pdwMsgHandle/*[out]*/)
{
  return GetDefaultInterface()->GetAsyncSubMessage(nAsync/*[in]*/, ppTime/*[in,out]*/, 
                                                   pdwMsgHandle/*[out]*/);
}

TOLEBOOL __fastcall TCross::GetAsyncConfirm(short nAsync/*[in]*/, long* pdwMsgHandle/*[out]*/)
{
  return GetDefaultInterface()->GetAsyncConfirm(nAsync/*[in]*/, pdwMsgHandle/*[out]*/);
}

TOLEBOOL __fastcall TCross::GetAsyncAnswer(short nAsync/*[in]*/, long* pdwMsgHandle/*[out]*/, 
                                           short* pnAnswer/*[out]*/)
{
  return GetDefaultInterface()->GetAsyncAnswer(nAsync/*[in]*/, pdwMsgHandle/*[out]*/, 
                                               pnAnswer/*[out]*/);
}

short __fastcall TCross::AsyncAddMessage(Wbf_timelib_tlb::IFileTimePtr pTime/*[in]*/, 
                                         long dwMsgHandle/*[in]*/, long eMessageType/*[in]*/, 
                                         long dwMessage/*[in]*/, BSTR bstrDBModule/*[in]*/, 
                                         BSTR bstrDBCause/*[in]*/, BSTR bstrDBMessage/*[in]*/, 
                                         TVariant* astrParams/*[in]*/, TVariant* abDBParams/*[in]*/)
{
  return GetDefaultInterface()->AsyncAddMessage(pTime/*[in]*/, dwMsgHandle/*[in]*/, 
                                                eMessageType/*[in]*/, dwMessage/*[in]*/, 
                                                bstrDBModule/*[in]*/, bstrDBCause/*[in]*/, 
                                                bstrDBMessage/*[in]*/, astrParams/*[in]*/, 
                                                abDBParams/*[in]*/);
}

TOLEBOOL __fastcall TCross::AsyncAddMessageResult(short nJob/*[in]*/, long* pdwMsgHandle/*[out]*/)
{
  return GetDefaultInterface()->AsyncAddMessageResult(nJob/*[in]*/, pdwMsgHandle/*[out]*/);
}

short __fastcall TCross::AsyncAddDialog(Wbf_timelib_tlb::IFileTimePtr pTime/*[in]*/, 
                                        long dwMsgHandle/*[in]*/, long eMessageType/*[in]*/, 
                                        long dwMessage/*[in]*/, BSTR bstrDBModule/*[in]*/, 
                                        BSTR bstrDBCause/*[in]*/, BSTR bstrDBMessage/*[in]*/, 
                                        TVariant* astrParams/*[in]*/, TVariant* abDBParams/*[in]*/, 
                                        TVariant* astrAnswers/*[in]*/, TVariant* abDBAnswers/*[in]*/)
{
  return GetDefaultInterface()->AsyncAddDialog(pTime/*[in]*/, dwMsgHandle/*[in]*/, 
                                               eMessageType/*[in]*/, dwMessage/*[in]*/, 
                                               bstrDBModule/*[in]*/, bstrDBCause/*[in]*/, 
                                               bstrDBMessage/*[in]*/, astrParams/*[in]*/, 
                                               abDBParams/*[in]*/, astrAnswers/*[in]*/, 
                                               abDBAnswers/*[in]*/);
}

TOLEBOOL __fastcall TCross::AsyncAddDialogResult(short nJob/*[in]*/, long* pdwMsgHandle/*[out]*/)
{
  return GetDefaultInterface()->AsyncAddDialogResult(nJob/*[in]*/, pdwMsgHandle/*[out]*/);
}

short __fastcall TCross::AsyncSubMessage(long dwMsgHandle/*[in]*/)
{
  return GetDefaultInterface()->AsyncSubMessage(dwMsgHandle/*[in]*/);
}

TOLEBOOL __fastcall TCross::AsyncSubMessageResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->AsyncSubMessageResult(nJob/*[in]*/);
}

short __fastcall TCross::AsyncConfirm(long dwMsgHandle/*[in]*/)
{
  return GetDefaultInterface()->AsyncConfirm(dwMsgHandle/*[in]*/);
}

TOLEBOOL __fastcall TCross::AsyncConfirmResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->AsyncConfirmResult(nJob/*[in]*/);
}

short __fastcall TCross::AsyncAnswer(long dwMsgHandle/*[in]*/, short nAnswer/*[in]*/)
{
  return GetDefaultInterface()->AsyncAnswer(dwMsgHandle/*[in]*/, nAnswer/*[in]*/);
}

TOLEBOOL __fastcall TCross::AsyncAnswerResult(short nJob/*[in]*/)
{
  return GetDefaultInterface()->AsyncAnswerResult(nJob/*[in]*/);
}


};     // namespace Crosslib_tlb


// *********************************************************************//
// La fonction Register est invoque par l'EDI lorsque ce module est 
// install dans un paquet. Il fournit la liste des composants (y-compris
// les OCX) implments par ce module. L'implmentation ci-dessous
// informe l'EDI des classes proxy OCX implmentes ici.
// *********************************************************************//
namespace Crosslib_ocx
{

void __fastcall PACKAGE Register()
{
  // [1]
  TComponentClass cls_ocx[] = {
                              __classid(Crosslib_tlb::TCross)
                           };
  RegisterComponents("ActiveX", cls_ocx,
                     sizeof(cls_ocx)/sizeof(cls_ocx[0])-1);
}

};     // namespace Crosslib_ocx
